/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         nft_parse
#define yylex           nft_lex
#define yyerror         nft_error
#define yydebug         nft_debug
#define yynerrs         nft_nerrs


/* Copy the first part of user declarations.  */
#line 11 "src/parser.y" /* yacc.c:339  */


#include <stddef.h>
#include <stdio.h>
#include <inttypes.h>
#include <netinet/ip.h>
#include <netinet/if_ether.h>
#include <linux/netfilter.h>
#include <linux/netfilter/nf_tables.h>
#include <linux/netfilter/nf_conntrack_tuple_common.h>
#include <libnftnl/common.h>

#include <rule.h>
#include <statement.h>
#include <expression.h>
#include <utils.h>
#include <parser.h>
#include <erec.h>

#include "parser.h"
#include "scanner.h"

void parser_init(struct parser_state *state, struct list_head *msgs)
{
	memset(state, 0, sizeof(*state));
	init_list_head(&state->cmds);
	init_list_head(&state->top_scope.symbols);
	state->msgs = msgs;
	state->scopes[0] = scope_init(&state->top_scope, NULL);
	state->ectx.msgs = msgs;
}

static void yyerror(struct location *loc, void *scanner,
		    struct parser_state *state, const char *s)
{
	erec_queue(error(loc, "%s", s), state->msgs);
}

static struct scope *current_scope(const struct parser_state *state)
{
	return state->scopes[state->scope];
}

static void open_scope(struct parser_state *state, struct scope *scope)
{
	assert(state->scope < array_size(state->scopes) - 1);
	scope_init(scope, current_scope(state));
	state->scopes[++state->scope] = scope;
}

static void close_scope(struct parser_state *state)
{
	assert(state->scope > 0);
	state->scope--;
}

static void location_init(void *scanner, struct parser_state *state,
			  struct location *loc)
{
	memset(loc, 0, sizeof(*loc));
	loc->indesc = state->indesc;
}

static void location_update(struct location *loc, struct location *rhs, int n)
{
	if (n) {
		loc->indesc       = rhs[n].indesc;
		loc->token_offset = rhs[1].token_offset;
		loc->line_offset  = rhs[1].line_offset;
		loc->first_line   = rhs[1].first_line;
		loc->first_column = rhs[1].first_column;
		loc->last_line    = rhs[n].last_line;
		loc->last_column  = rhs[n].last_column;
	} else {
		loc->indesc       = rhs[0].indesc;
		loc->token_offset = rhs[0].token_offset;
		loc->line_offset  = rhs[0].line_offset;
		loc->first_line   = loc->last_line   = rhs[0].last_line;
		loc->first_column = loc->last_column = rhs[0].last_column;
	}
}

#define YYLLOC_DEFAULT(Current, Rhs, N)	location_update(&Current, Rhs, N)

enum {
	NFT_EVENT_NEW	= 0,
	NFT_EVENT_DEL,
};

static int monitor_lookup_event(const char *event)
{
	if (strcmp(event, "new") == 0)
		return NFT_EVENT_NEW;
	else if (strcmp(event, "destroy") == 0)
		return NFT_EVENT_DEL;

	return -1;
}


#line 173 "src/parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.h.tmp".  */
#ifndef YY_NFT_SRC_PARSER_H_TMP_INCLUDED
# define YY_NFT_SRC_PARSER_H_TMP_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int nft_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOKEN_EOF = 0,
    JUNK = 258,
    NEWLINE = 259,
    COLON = 260,
    SEMICOLON = 261,
    COMMA = 262,
    DOT = 263,
    EQ = 264,
    NEQ = 265,
    LT = 266,
    GT = 267,
    GTE = 268,
    LTE = 269,
    LSHIFT = 270,
    RSHIFT = 271,
    AMPERSAND = 272,
    CARET = 273,
    NOT = 274,
    SLASH = 275,
    ASTERISK = 276,
    DASH = 277,
    AT = 278,
    VMAP = 279,
    INCLUDE = 280,
    DEFINE = 281,
    HOOK = 282,
    TABLE = 283,
    TABLES = 284,
    CHAIN = 285,
    CHAINS = 286,
    RULE = 287,
    RULES = 288,
    SETS = 289,
    SET = 290,
    ELEMENT = 291,
    MAP = 292,
    HANDLE = 293,
    INET = 294,
    ADD = 295,
    CREATE = 296,
    INSERT = 297,
    DELETE = 298,
    LIST = 299,
    FLUSH = 300,
    RENAME = 301,
    DESCRIBE = 302,
    EXPORT = 303,
    MONITOR = 304,
    ACCEPT = 305,
    DROP = 306,
    CONTINUE = 307,
    JUMP = 308,
    GOTO = 309,
    RETURN = 310,
    CONSTANT = 311,
    INTERVAL = 312,
    ELEMENTS = 313,
    NUM = 314,
    STRING = 315,
    QUOTED_STRING = 316,
    LL_HDR = 317,
    NETWORK_HDR = 318,
    TRANSPORT_HDR = 319,
    BRIDGE = 320,
    ETHER = 321,
    SADDR = 322,
    DADDR = 323,
    TYPE = 324,
    VLAN = 325,
    ID = 326,
    CFI = 327,
    PCP = 328,
    ARP = 329,
    HTYPE = 330,
    PTYPE = 331,
    HLEN = 332,
    PLEN = 333,
    OPERATION = 334,
    IP = 335,
    VERSION = 336,
    HDRLENGTH = 337,
    TOS = 338,
    LENGTH = 339,
    FRAG_OFF = 340,
    TTL = 341,
    PROTOCOL = 342,
    CHECKSUM = 343,
    ICMP = 344,
    CODE = 345,
    SEQUENCE = 346,
    GATEWAY = 347,
    MTU = 348,
    IP6 = 349,
    PRIORITY = 350,
    FLOWLABEL = 351,
    NEXTHDR = 352,
    HOPLIMIT = 353,
    ICMP6 = 354,
    PPTR = 355,
    MAXDELAY = 356,
    AH = 357,
    RESERVED = 358,
    SPI = 359,
    ESP = 360,
    COMP = 361,
    FLAGS = 362,
    CPI = 363,
    UDP = 364,
    SPORT = 365,
    DPORT = 366,
    UDPLITE = 367,
    CSUMCOV = 368,
    TCP = 369,
    ACKSEQ = 370,
    DOFF = 371,
    WINDOW = 372,
    URGPTR = 373,
    DCCP = 374,
    SCTP = 375,
    VTAG = 376,
    RT = 377,
    RT0 = 378,
    RT2 = 379,
    SEG_LEFT = 380,
    ADDR = 381,
    HBH = 382,
    FRAG = 383,
    RESERVED2 = 384,
    MORE_FRAGMENTS = 385,
    DST = 386,
    MH = 387,
    META = 388,
    NFPROTO = 389,
    L4PROTO = 390,
    MARK = 391,
    IIF = 392,
    IIFNAME = 393,
    IIFTYPE = 394,
    OIF = 395,
    OIFNAME = 396,
    OIFTYPE = 397,
    SKUID = 398,
    SKGID = 399,
    NFTRACE = 400,
    RTCLASSID = 401,
    IBRIPORT = 402,
    OBRIPORT = 403,
    CT = 404,
    DIRECTION = 405,
    STATE = 406,
    STATUS = 407,
    EXPIRATION = 408,
    HELPER = 409,
    L3PROTOCOL = 410,
    PROTO_SRC = 411,
    PROTO_DST = 412,
    LABEL = 413,
    COUNTER = 414,
    PACKETS = 415,
    BYTES = 416,
    LOG = 417,
    PREFIX = 418,
    GROUP = 419,
    SNAPLEN = 420,
    QUEUE_THRESHOLD = 421,
    LIMIT = 422,
    RATE = 423,
    NANOSECOND = 424,
    MICROSECOND = 425,
    MILLISECOND = 426,
    SECOND = 427,
    MINUTE = 428,
    HOUR = 429,
    DAY = 430,
    WEEK = 431,
    _REJECT = 432,
    SNAT = 433,
    DNAT = 434,
    QUEUE = 435,
    QUEUENUM = 436,
    QUEUEBYPASS = 437,
    QUEUECPUFANOUT = 438,
    POSITION = 439,
    COMMENT = 440,
    XML = 441,
    JSON = 442
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 133 "src/parser.y" /* yacc.c:355  */

	uint64_t		val;
	const char *		string;

	struct list_head	*list;
	struct cmd		*cmd;
	struct handle		handle;
	struct table		*table;
	struct chain		*chain;
	struct rule		*rule;
	struct stmt		*stmt;
	struct expr		*expr;
	struct set		*set;

#line 417 "src/parser.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int nft_parse (void *scanner, struct parser_state *state);

#endif /* !YY_NFT_SRC_PARSER_H_TMP_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 445 "src/parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1790

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  197
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  152
/* YYNRULES -- Number of rules.  */
#define YYNRULES  456
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  640

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   442

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,   191,     2,     2,     2,
     192,   193,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   188,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   195,     2,   196,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   189,   194,   190,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   516,   516,   517,   534,   535,   538,   539,   542,   550,
     563,   571,   572,   573,   574,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   621,   625,   632,   636,
     644,   648,   652,   659,   666,   672,   676,   683,   687,   697,
     703,   707,   711,   715,   719,   723,   729,   733,   737,   741,
     745,   751,   755,   759,   765,   772,   780,   790,   802,   830,
     835,   855,   860,   880,   885,   905,   910,   930,   935,   958,
     961,   965,   971,   972,   973,   974,   985,   995,  1008,  1014,
    1015,  1016,  1017,  1018,  1026,  1031,  1032,  1033,  1034,  1044,
    1049,  1056,  1060,  1063,  1064,  1068,  1074,  1075,  1076,  1077,
    1097,  1102,  1109,  1126,  1145,  1148,  1149,  1152,  1153,  1154,
    1155,  1156,  1157,  1160,  1168,  1176,  1183,  1190,  1197,  1205,
    1208,  1215,  1218,  1224,  1233,  1236,  1242,  1255,  1261,  1268,
    1269,  1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1280,
    1284,  1290,  1296,  1303,  1308,  1313,  1316,  1323,  1324,  1326,
    1332,  1336,  1339,  1343,  1349,  1350,  1353,  1359,  1363,  1366,
    1370,  1374,  1378,  1384,  1392,  1393,  1394,  1395,  1396,  1399,
    1405,  1408,  1413,  1420,  1424,  1429,  1435,  1436,  1439,  1445,
    1451,  1456,  1462,  1468,  1482,  1486,  1492,  1496,  1502,  1508,
    1515,  1529,  1538,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1558,  1559,  1563,  1569,  1570,  1576,  1577,  1583,  1584,  1590,
    1593,  1594,  1613,  1619,  1627,  1633,  1639,  1650,  1651,  1652,
    1655,  1656,  1659,  1665,  1666,  1667,  1668,  1671,  1678,  1683,
    1688,  1691,  1695,  1701,  1702,  1705,  1709,  1713,  1719,  1720,
    1721,  1722,  1723,  1724,  1727,  1731,  1735,  1739,  1743,  1747,
    1753,  1757,  1763,  1764,  1767,  1768,  1769,  1770,  1771,  1774,
    1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,
    1785,  1786,  1789,  1793,  1799,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1820,  1826,
    1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,
    1837,  1838,  1839,  1840,  1841,  1844,  1854,  1855,  1856,  1859,
    1863,  1871,  1872,  1873,  1876,  1880,  1888,  1889,  1890,  1891,
    1894,  1898,  1906,  1907,  1908,  1909,  1910,  1913,  1917,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1938,  1942,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1960,
    1964,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1981,
    1985,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2004,
    2008,  2017,  2018,  2019,  2020,  2021,  2024,  2028,  2037,  2038,
    2041,  2045,  2054,  2055,  2056,  2059,  2063,  2072,  2073,  2074,
    2075,  2078,  2082,  2091,  2092,  2093,  2094,  2097,  2101,  2110,
    2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2122,
    2126,  2135,  2136,  2137,  2140,  2144,  2153,  2154,  2155,  2156,
    2159,  2160,  2161,  2162,  2163,  2164,  2165,  2168,  2174,  2175,
    2178,  2184,  2185,  2186,  2187,  2190,  2196,  2202,  2208,  2211,
    2217,  2218,  2219,  2220,  2221,  2222,  2225,  2231,  2232,  2235,
    2241,  2242,  2243,  2244,  2245,  2248,  2249
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "$undefined", "\"junk\"", "\"newline\"",
  "\"colon\"", "\"semicolon\"", "\"comma\"", "\".\"", "\"==\"", "\"!=\"",
  "\"<\"", "\">\"", "\">=\"", "\"<=\"", "\"<<\"", "\">>\"", "\"&\"",
  "\"^\"", "\"!\"", "\"/\"", "\"*\"", "\"-\"", "\"@\"", "\"vmap\"",
  "\"include\"", "\"define\"", "\"hook\"", "\"table\"", "\"tables\"",
  "\"chain\"", "\"chains\"", "\"rule\"", "\"rules\"", "\"sets\"",
  "\"set\"", "\"element\"", "\"map\"", "\"handle\"", "\"inet\"", "\"add\"",
  "\"create\"", "\"insert\"", "\"delete\"", "\"list\"", "\"flush\"",
  "\"rename\"", "\"describe\"", "\"export\"", "\"monitor\"", "\"accept\"",
  "\"drop\"", "\"continue\"", "\"jump\"", "\"goto\"", "\"return\"",
  "\"constant\"", "\"interval\"", "\"elements\"", "\"number\"",
  "\"string\"", "QUOTED_STRING", "\"ll\"", "\"nh\"", "\"th\"",
  "\"bridge\"", "\"ether\"", "\"saddr\"", "\"daddr\"", "\"type\"",
  "\"vlan\"", "\"id\"", "\"cfi\"", "\"pcp\"", "\"arp\"", "\"htype\"",
  "\"ptype\"", "\"hlen\"", "\"plen\"", "\"operation\"", "\"ip\"",
  "\"version\"", "\"hdrlength\"", "\"tos\"", "\"length\"", "\"frag-off\"",
  "\"ttl\"", "\"protocol\"", "\"checksum\"", "\"icmp\"", "\"code\"",
  "\"seq\"", "\"gateway\"", "\"mtu\"", "\"ip6\"", "\"priority\"",
  "\"flowlabel\"", "\"nexthdr\"", "\"hoplimit\"", "\"icmpv6\"",
  "\"param-problem\"", "\"max-delay\"", "\"ah\"", "\"reserved\"",
  "\"spi\"", "\"esp\"", "\"comp\"", "\"flags\"", "\"cpi\"", "\"udp\"",
  "\"sport\"", "\"dport\"", "\"udplite\"", "\"csumcov\"", "\"tcp\"",
  "\"ackseq\"", "\"doff\"", "\"window\"", "\"urgptr\"", "\"dccp\"",
  "\"sctp\"", "\"vtag\"", "\"rt\"", "\"rt0\"", "\"rt2\"", "\"seg-left\"",
  "\"addr\"", "\"hbh\"", "\"frag\"", "\"reserved2\"", "\"more-fragments\"",
  "\"dst\"", "\"mh\"", "\"meta\"", "\"nfproto\"", "\"l4proto\"",
  "\"mark\"", "\"iif\"", "\"iifname\"", "\"iiftype\"", "\"oif\"",
  "\"oifname\"", "\"oiftype\"", "\"skuid\"", "\"skgid\"", "\"nftrace\"",
  "\"rtclassid\"", "\"ibriport\"", "\"obriport\"", "\"ct\"",
  "\"direction\"", "\"state\"", "\"status\"", "\"expiration\"",
  "\"helper\"", "\"l3proto\"", "\"proto-src\"", "\"proto-dst\"",
  "\"label\"", "\"counter\"", "\"packets\"", "\"bytes\"", "\"log\"",
  "\"prefix\"", "\"group\"", "\"snaplen\"", "\"queue-threshold\"",
  "\"limit\"", "\"rate\"", "\"nanosecond\"", "\"microsecond\"",
  "\"millisecond\"", "\"second\"", "\"minute\"", "\"hour\"", "\"day\"",
  "\"week\"", "\"reject\"", "\"snat\"", "\"dnat\"", "\"queue\"", "\"num\"",
  "\"bypass\"", "\"fanout\"", "\"position\"", "\"comment\"", "\"xml\"",
  "\"json\"", "'='", "'{'", "'}'", "'$'", "'('", "')'", "'|'", "'['",
  "']'", "$accept", "input", "stmt_seperator", "opt_newline",
  "common_block", "line", "base_cmd", "add_cmd", "create_cmd",
  "insert_cmd", "delete_cmd", "list_cmd", "flush_cmd", "rename_cmd",
  "export_cmd", "monitor_cmd", "monitor_flags", "output_format",
  "table_block_alloc", "table_block", "chain_block_alloc", "chain_block",
  "set_block_alloc", "set_block", "set_flag_list", "set_flag",
  "map_block_alloc", "map_block", "hook_spec", "identifier", "string",
  "family_spec", "table_spec", "tables_spec", "chain_spec",
  "chain_identifier", "set_spec", "set_identifier", "handle_spec",
  "position_spec", "ruleid_spec", "comment_spec", "rule", "stmt_list",
  "stmt", "verdict_stmt", "verdict_map_stmt", "verdict_map_expr",
  "verdict_map_list_expr", "verdict_map_list_member_expr", "counter_stmt",
  "counter_stmt_alloc", "counter_args", "counter_arg", "log_stmt",
  "log_stmt_alloc", "log_args", "log_arg", "limit_stmt", "time_unit",
  "reject_stmt", "nat_stmt", "nat_stmt_alloc", "nat_stmt_args",
  "queue_stmt", "queue_stmt_alloc", "queue_args", "queue_range",
  "queue_flags", "queue_flag", "match_stmt", "symbol_expr", "integer_expr",
  "primary_expr", "shift_expr", "and_expr", "exclusive_or_expr",
  "inclusive_or_expr", "basic_expr", "concat_expr", "list_expr",
  "prefix_expr", "range_expr", "wildcard_expr", "multiton_expr",
  "map_lhs_expr", "map_expr", "expr", "set_expr", "set_list_expr",
  "set_list_member_expr", "initializer_expr", "relational_expr",
  "relational_op", "verdict_expr", "meta_expr", "meta_key",
  "meta_key_qualified", "meta_key_unqualified", "meta_stmt", "ct_expr",
  "ct_key", "ct_stmt", "payload_expr", "payload_raw_expr",
  "payload_base_spec", "eth_hdr_expr", "eth_hdr_field", "vlan_hdr_expr",
  "vlan_hdr_field", "arp_hdr_expr", "arp_hdr_field", "ip_hdr_expr",
  "ip_hdr_field", "icmp_hdr_expr", "icmp_hdr_field", "ip6_hdr_expr",
  "ip6_hdr_field", "icmp6_hdr_expr", "icmp6_hdr_field", "auth_hdr_expr",
  "auth_hdr_field", "esp_hdr_expr", "esp_hdr_field", "comp_hdr_expr",
  "comp_hdr_field", "udp_hdr_expr", "udp_hdr_field", "udplite_hdr_expr",
  "udplite_hdr_field", "tcp_hdr_expr", "tcp_hdr_field", "dccp_hdr_expr",
  "dccp_hdr_field", "sctp_hdr_expr", "sctp_hdr_field", "exthdr_expr",
  "hbh_hdr_expr", "hbh_hdr_field", "rt_hdr_expr", "rt_hdr_field",
  "rt0_hdr_expr", "rt0_hdr_field", "rt2_hdr_expr", "rt2_hdr_field",
  "frag_hdr_expr", "frag_hdr_field", "dst_hdr_expr", "dst_hdr_field",
  "mh_hdr_expr", "mh_hdr_field", "export_format", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,    61,   123,
     125,    36,    40,    41,   124,    91,    93
};
# endif

#define YYPACT_NINF -511

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-511)))

#define YYTABLE_NINF -222

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -511,   435,  -511,   172,  -511,  -511,   -36,    28,    69,    69,
      69,    69,    69,    69,  -511,   181,   194,    68,   418,   267,
      15,    19,  1598,   -26,   380,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,   280,  -511,    28,    28,    53,  1316,  -511,   172,
    -511,   -82,   -78,   -71,  1316,    28,  -511,   -57,  -511,  -511,
      69,    69,  -511,    69,  -511,    69,    69,    69,    69,    69,
      69,  -511,    69,    69,    69,    69,    69,  -511,    69,    69,
      69,  -511,    69,  -511,   430,  -511,  -511,  -511,   257,   433,
     481,   858,   420,   248,   452,   147,   -47,    75,    58,    79,
     575,   -32,    43,   -35,    13,    22,   -30,    44,     0,   -11,
     441,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,   112,    28,  1598,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,   259,  -511,
     -26,  -511,  -511,  -511,  -511,   116,   -13,  -511,  -511,  -511,
    -511,    28,    28,  -511,   441,   112,  -511,  -511,    23,  -511,
    -511,  -511,  -511,   183,  -511,  1173,  -511,  -511,  -511,  -511,
      34,  -511,   293,  -511,  -511,  -511,   889,  -511,   167,  -511,
    -511,   188,   190,   182,    27,   236,   113,  -511,  -511,  -511,
    -511,  -511,  1030,  -511,  -511,  -511,   175,  -511,  -511,  -511,
    1410,    41,    45,  -511,  -511,    48,  -511,    71,   -78,   -71,
    1316,  -511,  -511,  -511,  -511,   -57,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,    28,  -511,  -511,  -511,
    -511,   235,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,    52,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,    60,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,   218,  -511,
    -511,  -511,   252,   263,   230,  -511,  1410,     8,  -511,   154,
    -511,  -511,   261,   262,    34,  -511,   154,   269,   271,   272,
     293,  -511,  1410,  -511,    56,   289,   294,  -511,  -511,  -511,
      90,  -511,  1598,  1598,  1598,  1598,  1598,   295,  1598,  1598,
     168,  1410,  -511,  -511,  -511,  -511,  -511,  -511,   205,   349,
    -511,  1410,  1410,   349,  -511,   172,  -511,  -511,  -511,  -511,
     171,   174,  -511,  -511,  -511,   302,   307,  -511,  -511,  1410,
    1410,   348,    64,   364,   369,   183,   183,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  1410,   356,
      90,  -511,  -511,  -511,   188,   190,   182,  -511,  -511,  -511,
     183,  -511,  -511,  1598,  1598,  -511,  -511,  -511,    16,   253,
      29,    55,  -511,  -511,   372,   186,  -511,  -511,   393,  1598,
    -511,  1410,  -511,  -511,   328,    90,  1504,    11,  -511,  -511,
    -511,    28,    28,    28,  -511,  -511,  -511,   343,  -511,  -511,
    -511,   172,   172,   200,    28,   254,  -511,  -511,  -511,   216,
      28,   254,  -511,  -511,  -511,    59,   595,   351,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,    95,  -511,   399,  -511,
     403,   183,  -511,  -511,  -511,  -511,  -511,  -511,   392,  -511,
    -511,   -57,   172,  -511,  -511,   151,  -511,   -57,   417,   151,
    -511,  -511,  -511,  -511,   284,  1504,  -511,   234,   240,   245,
     365,  -511,  -511,   254,  -511,  -511,    28,  -511,   183,  -511,
    -511,  -511,   342,  -511,   172,  -511,   744,   101,   119,    14,
    -511,   172,   172,   172,   388,  -511,  -511,  -511,  -511,  -511
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     4,     5,     0,     0,   107,   107,
     107,   107,   107,   107,   110,   107,     0,     0,     0,     0,
       0,     0,     0,     0,    57,   112,   111,   108,   109,    12,
      11,     3,     0,    15,     0,     0,   119,     0,    10,     0,
     104,     0,    26,    28,     0,     0,    84,     0,    95,    16,
     107,   107,    17,   107,    18,   107,   107,   107,   107,   107,
     107,    19,   107,   107,   107,   107,   107,    20,   107,   107,
     107,    21,   107,    22,     0,   192,   105,   106,   310,   315,
     321,   328,   341,   350,   360,   370,   377,   381,   386,   392,
     398,   410,   415,     0,     0,     0,     0,     0,     0,     0,
       0,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,     0,     0,   189,   193,   194,
      25,   197,   251,   198,   195,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   196,   420,   421,   422,   423,   424,   425,   426,   455,
     456,    23,    55,    59,    61,    65,    63,    67,    58,    24,
      69,    14,    13,   113,   115,     0,   121,   216,   244,   245,
     246,     0,     0,   249,     0,     0,   149,   156,     0,   169,
     171,   172,   178,     7,    31,   124,   127,   129,   140,   131,
     147,   133,   154,   134,   135,   136,     0,   137,   176,   130,
     200,   203,   205,   207,   209,   210,   223,   217,   218,   219,
     226,   225,     0,   224,   188,   139,   251,   132,   138,     8,
       0,     0,     0,    30,   117,     0,    34,     0,    35,    37,
       0,    40,    41,    42,    43,     0,    44,    46,   114,    47,
      48,    49,    50,    51,    52,    53,     0,   306,   307,   308,
     191,     0,   311,   312,   313,   309,   319,   316,   317,   318,
     314,   322,   323,   324,   325,   326,   320,   338,   339,   333,
     329,   330,   331,   332,   334,   335,   336,   337,   327,   342,
     345,   344,   343,   346,   347,   348,   340,   357,   358,   351,
     354,   352,   353,   355,   356,   349,   361,   366,   363,   362,
     367,   365,   364,   368,   359,   372,   375,   371,   373,   374,
     369,   379,   378,   376,   382,   383,   384,   380,   389,   390,
     387,   388,   385,   396,   393,   394,   395,   391,   407,   401,
     404,   405,   399,   400,   402,   403,   406,   408,   397,   413,
     411,   412,   409,   419,   416,   417,   418,   414,   433,   432,
     431,   434,   430,     0,   435,   438,   437,   429,   428,   427,
     445,   442,   440,   441,   443,   444,   439,   448,   447,   446,
     452,   451,   454,   450,   453,   449,   254,   257,   258,   255,
     256,   250,   252,   253,   282,   283,   284,   278,   276,   275,
     277,   279,   280,   281,   285,   286,   287,   274,   190,     0,
      60,    62,    66,    64,    68,    56,    70,   120,     0,   123,
     247,   248,   250,   274,     0,     6,     0,     0,   228,     0,
     126,   128,     0,     0,   148,   150,     0,     0,     0,     0,
     155,   157,     0,   170,   223,   173,     0,   186,   187,   177,
     181,   184,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   238,   239,   240,   241,   242,   243,   210,   236,
     235,     0,     0,   234,   233,     0,    72,    79,    85,    96,
       0,     0,    39,    45,    54,     0,     0,   199,   122,     0,
       0,     0,   223,   226,     0,     7,     7,   227,   125,   152,
     153,   151,   159,   160,   161,   162,   158,   175,     0,   182,
     180,   185,   201,   202,   204,   206,   208,   214,   215,   211,
       7,   141,   222,     0,     0,   237,   273,     9,     0,     0,
       0,     0,    72,    79,     0,     0,   272,   288,     0,     0,
     231,   230,   229,   174,     0,   179,     0,     0,   143,   212,
     213,     0,     0,     0,    27,    74,    73,     0,    29,    81,
      80,     0,     0,     0,     0,     0,    32,    87,    86,     0,
       0,     0,    33,    98,    97,     0,     0,     0,   436,   164,
     165,   166,   167,   168,   163,   210,     7,   183,   221,   220,
       0,     7,   142,   116,    78,   118,    84,    95,     0,    82,
      83,     0,     0,    93,    94,     0,    92,     0,     0,     0,
      36,    38,   305,   232,     0,   145,   144,     0,     0,     0,
       0,    90,    88,     0,    89,   101,     0,   100,     7,    79,
      85,    96,     0,    91,     0,   146,     0,     0,     0,     0,
      99,     0,     0,     0,     0,   102,    75,    76,    77,   103
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -511,  -511,    -1,  -462,     6,  -511,  -511,   434,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,   223,   -70,
    -220,  -509,  -124,  -154,   -93,  -144,  -114,  -134,  -511,    -6,
    -343,   220,   173,   423,    66,  -511,   358,   -46,  -511,  -511,
      17,  -511,   -25,  -511,   314,  -511,  -511,  -511,  -511,   -80,
    -511,  -511,  -511,    83,  -511,  -511,  -511,    84,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,    18,  -419,
    -511,  -511,  -511,   -16,    72,    77,    85,  -511,  -108,   -33,
     310,  -511,  -511,  -511,  -403,  -510,  -511,  -180,   -42,  -511,
      51,  -511,  -511,  -511,   -66,  -511,   360,  -511,   -34,  -511,
    -511,   366,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,  -511,
    -511,   379
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   549,   416,   550,    31,    32,    33,    52,    54,
      61,    67,    71,    73,   151,   159,   160,   405,   221,   518,
     222,   519,   225,   520,   595,   596,   227,   521,   551,   585,
     117,    34,    35,   239,    36,   584,    46,   586,   166,   409,
      37,   420,   552,   185,   186,   187,   188,   511,   537,   538,
     189,   190,   424,   425,   191,   192,   430,   431,   193,   574,
     194,   195,   196,   433,   197,   198,   439,   500,   440,   441,
     199,   118,   119,   200,   201,   202,   203,   204,   205,   434,
     459,   207,   208,   209,   210,   484,   211,   212,   213,   417,
     418,   465,   214,   461,   215,   121,   381,   382,   122,   217,
     123,   397,   218,   124,   125,   251,   126,   255,   127,   260,
     128,   266,   129,   278,   130,   286,   131,   295,   132,   304,
     133,   310,   134,   313,   135,   317,   136,   322,   137,   327,
     138,   338,   139,   342,   140,   347,   141,   142,   359,   143,
     352,   144,   354,   145,   356,   146,   366,   147,   369,   148,
     375,   152
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      29,    41,    38,   216,   206,   226,   120,    30,   399,   471,
     216,   206,   184,   483,   566,   486,   435,     3,   581,   223,
       4,   501,     5,   530,   531,    39,   580,    44,   163,   164,
       3,   162,   460,     4,   348,     5,   634,   339,   219,   224,
     464,     6,     7,    68,   311,    69,   541,   349,   536,    72,
      70,   542,   357,   543,     6,     7,     3,   312,   370,     4,
       3,     5,   350,     4,   449,     5,   383,   358,   250,  -221,
     230,   371,   449,   635,   233,    43,   488,   372,   340,   341,
       6,     7,   367,   492,     6,     7,   373,   553,    40,   541,
     351,   165,   374,   451,   542,   580,   543,   368,   554,   415,
      53,   451,     3,   449,   458,     4,   220,     5,    14,   398,
     626,   -71,   458,   559,   603,   360,   501,   229,   -78,   605,
       3,   449,   232,     4,   560,     5,     6,     7,   483,   361,
     240,   343,   183,   579,    25,   244,   555,   450,   246,   353,
     383,   362,   318,    26,     6,     7,   319,   363,   355,    27,
     451,   216,   206,   344,   345,     4,   625,     5,   613,   553,
     149,   150,   561,    28,   346,   410,   411,   323,   320,   321,
     554,   408,   314,   364,   365,   407,     4,   559,     5,   384,
     385,    42,   315,   316,    45,    45,    45,   415,   560,   324,
     325,   414,   326,   473,   422,   423,   216,   206,   487,   386,
     445,   582,   579,   442,   443,   472,   544,   444,   555,     8,
     462,     9,   513,    10,    76,    77,    11,    12,    13,   556,
      14,   446,    50,   228,    51,   447,   561,   448,   231,   305,
     466,    45,    45,    45,   467,   237,   485,   468,   306,    45,
     474,   243,   475,    45,   307,   562,    25,   476,   387,   600,
     308,   309,   497,   477,     3,    26,   447,     4,   448,     5,
     469,    27,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   512,   437,   438,   167,    28,    74,   478,     6,     7,
     161,   515,   516,   238,     4,   238,     5,   479,   400,   481,
     401,   632,   402,   403,   498,    62,    63,    64,   480,   526,
     527,    65,    66,   168,   169,   170,   171,   172,   173,   633,
     593,   594,    75,    76,    77,   287,   288,   404,   533,    78,
     489,   490,   547,    79,   252,   253,   254,    80,   493,   289,
     494,   495,   290,    81,   168,   169,   170,   171,   172,   173,
     508,   509,    82,   291,   292,   293,   294,    83,   436,   437,
     438,   485,    84,   499,   507,    85,   514,   510,    86,    87,
     522,   524,    88,   523,   607,    89,   525,    90,   528,  -220,
      47,    48,    91,    92,   529,    93,    94,    95,   534,   567,
      96,    97,   568,   482,    98,    99,   174,   577,   591,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   175,   588,   597,   539,   540,   449,   604,   153,
     602,   154,   176,   155,   156,   177,   234,   235,   236,   610,
     178,   575,   616,   619,   242,   622,   502,   503,   245,   620,
     179,   180,   181,   182,   621,     2,     3,   629,   157,     4,
     158,     5,   183,   548,   115,   116,    55,   639,    56,    49,
      57,   470,   565,    58,    59,    60,   426,   427,   428,   429,
       6,     7,   608,     8,   517,     9,   627,    10,   599,   623,
      11,    12,    13,   609,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,   216,   206,   628,   241,   279,
      40,   280,   247,   248,   249,  -107,   576,   587,   482,   421,
      25,   606,   256,   578,   257,   258,   259,   491,   281,    26,
     282,   283,   284,   285,   496,    27,   504,   545,   535,   557,
     563,   296,   505,   297,   546,   376,   558,   564,   377,    28,
     463,   506,   216,   206,   412,   583,   378,   532,   618,   406,
     298,   413,   299,   300,     0,   301,     0,     0,   592,   611,
     589,   590,   302,   303,   598,   615,   261,   262,   263,   264,
     265,     0,     0,     0,   545,   569,   570,   571,   572,   573,
       0,   546,   578,     0,     0,   379,   380,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
       0,   612,   216,   206,   614,     0,     3,     0,   617,     4,
       0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
     624,     0,     0,     0,     0,     0,   167,     0,    74,     0,
       6,     7,     0,   630,     0,     0,   557,   563,     0,     0,
     636,   637,   638,   558,   564,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   168,   169,   170,   171,   172,
     173,     0,     0,     0,    75,    76,    77,     0,     0,     0,
       0,    78,     0,   328,   547,    79,   329,     0,     0,    80,
       0,     0,     0,     0,     0,    81,     0,     0,   330,     0,
       0,     0,   331,     0,    82,   332,   333,     0,     0,    83,
     334,   335,   336,   337,    84,     0,     0,    85,     0,     0,
      86,    87,     0,     0,    88,     0,     0,    89,     0,    90,
       0,     0,     0,     0,    91,    92,     0,    93,    94,    95,
       0,     0,    96,    97,     0,     0,    98,    99,   174,     0,
       0,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   175,     3,     0,     0,     4,     0,
       5,     0,     0,     0,   176,     0,     0,   177,     0,     0,
       0,     0,   178,     0,     0,   167,     0,    74,     0,     6,
       7,     0,   179,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,     0,   183,   601,   115,   116,     0,     0,
       0,     0,     0,     0,   168,   169,   170,   171,   172,   173,
       0,     0,     0,    75,    76,    77,     0,     0,     0,     0,
      78,     0,     0,   547,    79,     0,     0,     0,    80,     0,
       0,     0,     0,     0,    81,     0,     0,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,    83,     0,
       0,     0,     0,    84,     0,     0,    85,     0,     0,    86,
      87,     0,     0,    88,     0,     0,    89,     0,    90,     0,
       0,     0,     0,    91,    92,     0,    93,    94,    95,     0,
       0,    96,    97,     0,     0,    98,    99,   174,     0,     0,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   175,   432,     0,     0,     0,     0,     0,
       0,     0,     0,   176,     0,     0,   177,     0,     0,     0,
     167,   178,    74,     0,     0,     0,     0,     0,     0,     0,
       0,   179,   180,   181,   182,   267,   268,     0,     0,   269,
       0,     0,     0,   183,   631,   115,   116,     0,     0,   270,
     271,   272,   273,   274,   275,   276,   277,     0,    75,    76,
      77,     0,     0,     0,     0,    78,     0,     0,     0,    79,
       0,     0,     0,    80,     0,     0,     0,     0,     0,    81,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,    83,     0,     0,     0,     0,    84,     0,
       0,    85,     0,     0,    86,    87,     0,     0,    88,     0,
       0,    89,     0,    90,     0,     0,     0,     0,    91,    92,
       0,    93,    94,    95,     0,     0,    96,    97,     0,     0,
      98,    99,   100,     0,     0,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   452,
     453,   454,   455,   456,   457,     0,     0,     0,     0,     0,
       0,   167,     0,    74,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   183,     0,
     115,   116,     0,     0,     0,     0,     0,     0,     0,    75,
      76,    77,     0,     0,     0,     0,    78,     0,     0,     0,
      79,     0,     0,     0,    80,     0,     0,     0,     0,     0,
      81,     0,     0,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,    83,     0,     0,     0,     0,    84,
       0,     0,    85,     0,     0,    86,    87,     0,     0,    88,
       0,     0,    89,     0,    90,     0,     0,     0,     0,    91,
      92,     0,    93,    94,    95,     0,     0,    96,    97,     0,
       0,    98,    99,   100,     0,     0,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   167,     0,    74,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   183,
       0,   115,   116,   168,   169,   170,   171,   172,   173,     0,
       0,     0,    75,    76,    77,     0,     0,     0,     0,    78,
       0,     0,     0,    79,     0,     0,     0,    80,     0,     0,
       0,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,    83,     0,     0,
       0,     0,    84,     0,     0,    85,     0,     0,    86,    87,
       0,     0,    88,     0,     0,    89,     0,    90,     0,     0,
       0,     0,    91,    92,     0,    93,    94,    95,     0,     0,
      96,    97,     0,     0,    98,    99,   174,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   175,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   176,     0,     0,   177,     0,   167,     0,    74,
     178,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     179,   180,   181,   182,     0,     0,     0,     0,   419,     0,
       0,     0,   183,     0,   115,   116,   168,   169,   170,   171,
     172,   173,     0,     0,     0,    75,    76,    77,     0,     0,
       0,     0,    78,     0,     0,     0,    79,     0,     0,     0,
      80,     0,     0,     0,     0,     0,    81,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
      83,     0,     0,     0,     0,    84,     0,     0,    85,     0,
       0,    86,    87,     0,     0,    88,     0,     0,    89,     0,
      90,   167,     0,    74,     0,    91,    92,     0,    93,    94,
      95,     0,     0,    96,    97,     0,     0,    98,    99,   174,
       0,     0,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   175,     0,     0,     0,    75,
      76,    77,     0,     0,     0,   176,    78,     0,   177,     0,
      79,     0,     0,   178,    80,     0,     0,     0,     0,     0,
      81,     0,     0,   179,   180,   181,   182,     0,     0,    82,
       0,     0,     0,     0,    83,   183,     0,   115,   116,    84,
       0,     0,    85,     0,     0,    86,    87,     0,     0,    88,
       0,     0,    89,     0,    90,   167,     0,    74,     0,    91,
      92,     0,    93,    94,    95,     0,     0,    96,    97,     0,
       0,    98,    99,   100,     0,     0,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,     0,     0,    75,    76,    77,     0,     0,     0,     0,
      78,     0,     0,     0,    79,     0,     0,     0,    80,     0,
       0,     0,     0,     0,    81,     0,     0,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,    83,   183,
       0,   115,   116,    84,     0,     0,    85,     0,     0,    86,
      87,     0,     0,    88,     0,     0,    89,     0,    90,     0,
       0,    74,     0,    91,    92,     0,    93,    94,    95,     0,
       0,    96,    97,     0,     0,    98,    99,   100,     0,     0,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,    75,    76,    77,
       0,     0,     0,     0,    78,     0,     0,     0,    79,     0,
       0,     0,    80,     0,     0,     0,     0,     0,    81,     0,
       0,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,    83,     0,     0,   115,   116,    84,     0,     0,
      85,     0,     0,    86,    87,     0,     0,    88,     0,     0,
      89,     0,    90,     0,     0,     0,     0,    91,    92,     0,
      93,    94,    95,     0,     0,    96,    97,     0,     0,    98,
      99,   100,     0,     0,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   115,
     116
};

static const yytype_int16 yycheck[] =
{
       1,     7,     3,    37,    37,    47,    22,     1,   116,   229,
      44,    44,    37,   416,   523,     7,   196,     1,     7,    44,
       4,   440,     6,   485,   486,    61,   536,    10,    34,    35,
       1,    32,   212,     4,    69,     6,    22,    69,    39,    45,
     220,    25,    26,    28,    91,    30,    30,    82,   510,    30,
      35,    35,    82,    37,    25,    26,     1,   104,    69,     4,
       1,     6,    97,     4,     8,     6,   100,    97,    74,     5,
      53,    82,     8,    59,    57,     9,   419,    88,   110,   111,
      25,    26,    82,   426,    25,    26,    97,    58,    60,    30,
     125,    38,   103,    37,    35,   605,    37,    97,    69,     4,
      32,    37,     1,     8,   212,     4,   188,     6,    39,   115,
     619,   189,   220,    58,   576,    71,   535,    51,   189,   581,
       1,     8,    56,     4,    69,     6,    25,    26,   531,    85,
      64,    88,   189,   536,    65,    69,   107,    24,    72,   126,
     174,    97,    84,    74,    25,    26,    88,   103,   126,    80,
      37,   185,   185,   110,   111,     4,   618,     6,     7,    58,
     186,   187,   107,    94,   121,   171,   172,    88,   110,   111,
      69,   184,    97,   129,   130,    59,     4,    58,     6,    67,
      68,     8,   107,   108,    11,    12,    13,     4,    69,   110,
     111,   168,   113,   235,   160,   161,   230,   230,   190,    87,
      18,   190,   605,    15,    16,   230,   190,    17,   107,    28,
      35,    30,     7,    32,    60,    61,    35,    36,    37,   190,
      39,   194,    28,    50,    30,    20,   107,    22,    55,    82,
     189,    58,    59,    60,   189,    62,   416,   189,    91,    66,
     246,    68,     7,    70,    97,   190,    65,   195,   136,   190,
     103,   104,   432,   193,     1,    74,    20,     4,    22,     6,
     189,    80,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   451,   182,   183,    21,    94,    23,    59,    25,    26,
       0,   461,   462,    63,     4,    65,     6,    35,    29,    59,
      31,   190,    33,    34,     5,    28,    29,    30,    35,   479,
     480,    34,    35,    50,    51,    52,    53,    54,    55,   190,
      56,    57,    59,    60,    61,    67,    68,    58,   498,    66,
      59,    59,    69,    70,    67,    68,    69,    74,    59,    81,
      59,    59,    84,    80,    50,    51,    52,    53,    54,    55,
     448,   449,    89,    95,    96,    97,    98,    94,   181,   182,
     183,   531,    99,    59,    59,   102,     7,   189,   105,   106,
     189,    59,   109,   189,   584,   112,    59,   114,    20,     5,
      12,    13,   119,   120,     5,   122,   123,   124,    22,     7,
     127,   128,   196,   416,   131,   132,   133,    59,   188,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    60,   188,   513,   514,     8,     5,    29,
      59,    31,   159,    33,    34,   162,    58,    59,    60,    27,
     167,   529,     5,   189,    66,    60,   442,   443,    70,   189,
     177,   178,   179,   180,   189,     0,     1,    95,    58,     4,
      60,     6,   189,   190,   191,   192,    28,    59,    30,    15,
      32,   228,   522,    35,    36,    37,   163,   164,   165,   166,
      25,    26,   586,    28,   465,    30,   620,    32,   561,   613,
      35,    36,    37,   587,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,   519,   519,   621,    65,    69,
      60,    71,    62,    63,    64,    60,   529,   543,   531,   185,
      65,   581,    69,   536,    71,    72,    73,   424,    88,    74,
      90,    91,    92,    93,   430,    80,   444,   518,   500,   520,
     521,    69,   445,    71,   518,    84,   520,   521,    87,    94,
     220,   446,   566,   566,   174,   541,    95,   486,   604,   160,
      88,   175,    90,    91,    -1,    93,    -1,    -1,   554,   591,
     551,   552,   100,   101,   560,   597,    75,    76,    77,    78,
      79,    -1,    -1,    -1,   565,   172,   173,   174,   175,   176,
      -1,   565,   605,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   592,   626,   626,   595,    -1,     1,    -1,   599,     4,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     616,    -1,    -1,    -1,    -1,    -1,    21,    -1,    23,    -1,
      25,    26,    -1,   624,    -1,    -1,   627,   628,    -1,    -1,
     631,   632,   633,   627,   628,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,    -1,
      -1,    66,    -1,    88,    69,    70,    91,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,   103,    -1,
      -1,    -1,   107,    -1,    89,   110,   111,    -1,    -1,    94,
     115,   116,   117,   118,    99,    -1,    -1,   102,    -1,    -1,
     105,   106,    -1,    -1,   109,    -1,    -1,   112,    -1,   114,
      -1,    -1,    -1,    -1,   119,   120,    -1,   122,   123,   124,
      -1,    -1,   127,   128,    -1,    -1,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,     1,    -1,    -1,     4,    -1,
       6,    -1,    -1,    -1,   159,    -1,    -1,   162,    -1,    -1,
      -1,    -1,   167,    -1,    -1,    21,    -1,    23,    -1,    25,
      26,    -1,   177,   178,   179,   180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   189,   190,   191,   192,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    -1,    -1,
      66,    -1,    -1,    69,    70,    -1,    -1,    -1,    74,    -1,
      -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    94,    -1,
      -1,    -1,    -1,    99,    -1,    -1,   102,    -1,    -1,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,    -1,   114,    -1,
      -1,    -1,    -1,   119,   120,    -1,   122,   123,   124,    -1,
      -1,   127,   128,    -1,    -1,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   159,    -1,    -1,   162,    -1,    -1,    -1,
      21,   167,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,   178,   179,   180,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,   189,   190,   191,   192,    -1,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    59,    60,
      61,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    -1,    -1,    94,    -1,    -1,    -1,    -1,    99,    -1,
      -1,   102,    -1,    -1,   105,   106,    -1,    -1,   109,    -1,
      -1,   112,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,
      -1,   122,   123,   124,    -1,    -1,   127,   128,    -1,    -1,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    21,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,    -1,
     191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      60,    61,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,    -1,    99,
      -1,    -1,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
      -1,    -1,   112,    -1,   114,    -1,    -1,    -1,    -1,   119,
     120,    -1,   122,   123,   124,    -1,    -1,   127,   128,    -1,
      -1,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    -1,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
      -1,   191,   192,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    59,    60,    61,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    -1,    -1,    94,    -1,    -1,
      -1,    -1,    99,    -1,    -1,   102,    -1,    -1,   105,   106,
      -1,    -1,   109,    -1,    -1,   112,    -1,   114,    -1,    -1,
      -1,    -1,   119,   120,    -1,   122,   123,   124,    -1,    -1,
     127,   128,    -1,    -1,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,    -1,    -1,   162,    -1,    21,    -1,    23,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     177,   178,   179,   180,    -1,    -1,    -1,    -1,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    -1,    99,    -1,    -1,   102,    -1,
      -1,   105,   106,    -1,    -1,   109,    -1,    -1,   112,    -1,
     114,    21,    -1,    23,    -1,   119,   120,    -1,   122,   123,
     124,    -1,    -1,   127,   128,    -1,    -1,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,    -1,    -1,    59,
      60,    61,    -1,    -1,    -1,   159,    66,    -1,   162,    -1,
      70,    -1,    -1,   167,    74,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,   177,   178,   179,   180,    -1,    -1,    89,
      -1,    -1,    -1,    -1,    94,   189,    -1,   191,   192,    99,
      -1,    -1,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
      -1,    -1,   112,    -1,   114,    21,    -1,    23,    -1,   119,
     120,    -1,   122,   123,   124,    -1,    -1,   127,   128,    -1,
      -1,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    -1,    -1,
      66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    74,    -1,
      -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    94,   189,
      -1,   191,   192,    99,    -1,    -1,   102,    -1,    -1,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,    -1,   114,    -1,
      -1,    23,    -1,   119,   120,    -1,   122,   123,   124,    -1,
      -1,   127,   128,    -1,    -1,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,    -1,    -1,    59,    60,    61,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,
      -1,    -1,    94,    -1,    -1,   191,   192,    99,    -1,    -1,
     102,    -1,    -1,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,    -1,
     122,   123,   124,    -1,    -1,   127,   128,    -1,    -1,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
     192
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   198,     0,     1,     4,     6,    25,    26,    28,    30,
      32,    35,    36,    37,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    65,    74,    80,    94,   199,
     201,   202,   203,   204,   228,   229,   231,   237,   199,    61,
      60,   226,   229,   231,   237,   229,   233,   233,   233,   204,
      28,    30,   205,    32,   206,    28,    30,    32,    35,    36,
      37,   207,    28,    29,    30,    34,    35,   208,    28,    30,
      35,   209,    30,   210,    23,    59,    60,    61,    66,    70,
      74,    80,    89,    94,    99,   102,   105,   106,   109,   112,
     114,   119,   120,   122,   123,   124,   127,   128,   131,   132,
     133,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   191,   192,   227,   268,   269,
     270,   292,   295,   297,   300,   301,   303,   305,   307,   309,
     311,   313,   315,   317,   319,   321,   323,   325,   327,   329,
     331,   333,   334,   336,   338,   340,   342,   344,   346,   186,
     187,   211,   348,    29,    31,    33,    34,    58,    60,   212,
     213,     0,   199,   226,   226,    38,   235,    21,    50,    51,
      52,    53,    54,    55,   133,   149,   159,   162,   167,   177,
     178,   179,   180,   189,   239,   240,   241,   242,   243,   247,
     248,   251,   252,   255,   257,   258,   259,   261,   262,   267,
     270,   271,   272,   273,   274,   275,   276,   278,   279,   280,
     281,   283,   284,   285,   289,   291,   295,   296,   299,   199,
     188,   215,   217,   239,   226,   219,   285,   223,   229,   231,
     237,   229,   231,   237,   233,   233,   233,   229,   228,   230,
     231,   230,   233,   229,   231,   233,   231,    62,    63,    64,
     226,   302,    67,    68,    69,   304,    69,    71,    72,    73,
     306,    75,    76,    77,    78,    79,   308,    67,    68,    71,
      81,    82,    83,    84,    85,    86,    87,    88,   310,    69,
      71,    88,    90,    91,    92,    93,   312,    67,    68,    81,
      84,    95,    96,    97,    98,   314,    69,    71,    88,    90,
      91,    93,   100,   101,   316,    82,    91,    97,   103,   104,
     318,    91,   104,   320,    97,   107,   108,   322,    84,    88,
     110,   111,   324,    88,   110,   111,   113,   326,    88,    91,
     103,   107,   110,   111,   115,   116,   117,   118,   328,    69,
     110,   111,   330,    88,   110,   111,   121,   332,    69,    82,
      97,   125,   337,   126,   339,   126,   341,    82,    97,   335,
      71,    85,    97,   103,   129,   130,   343,    82,    97,   345,
      69,    82,    88,    97,   103,   347,    84,    87,    95,   134,
     135,   293,   294,   295,    67,    68,    87,   136,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   298,   226,   275,
      29,    31,    33,    34,    58,   214,   348,    59,   184,   236,
     226,   226,   293,   298,   168,     4,   200,   286,   287,   185,
     238,   241,   160,   161,   249,   250,   163,   164,   165,   166,
     253,   254,     5,   260,   276,   284,   181,   182,   183,   263,
     265,   266,    15,    16,    17,    18,   194,    20,    22,     8,
      24,    37,     9,    10,    11,    12,    13,    14,   275,   277,
     284,   290,    35,   277,   284,   288,   189,   189,   189,   189,
     215,   217,   239,   285,   226,     7,   195,   193,    59,    35,
      35,    59,   276,   281,   282,   284,     7,   190,   227,    59,
      59,   250,   227,    59,    59,    59,   254,   284,     5,    59,
     264,   266,   270,   270,   271,   272,   273,    59,   275,   275,
     189,   244,   284,     7,     7,   284,   284,   199,   216,   218,
     220,   224,   189,   189,    59,    59,   284,   284,    20,     5,
     200,   200,   287,   284,    22,   265,   200,   245,   246,   275,
     275,    30,    35,    37,   190,   199,   201,    69,   190,   199,
     201,   225,   239,    58,    69,   107,   190,   199,   201,    58,
      69,   107,   190,   199,   201,   216,   218,     7,   196,   172,
     173,   174,   175,   176,   256,   275,   276,    59,   276,   281,
     282,     7,   190,   226,   232,   226,   234,   234,    60,   199,
     199,   188,   226,    56,    57,   221,   222,   188,   226,   221,
     190,   190,    59,   200,     5,   200,   246,   217,   219,   223,
      27,   285,   199,     7,   199,   285,     5,   199,   291,   189,
     189,   189,    60,   222,   226,   200,   218,   220,   224,    95,
     199,   190,   190,   190,    22,    59,   199,   199,   199,    59
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   197,   198,   198,   199,   199,   200,   200,   201,   201,
     201,   202,   202,   202,   202,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   203,   204,   204,   204,   204,
     204,   204,   204,   204,   204,   205,   205,   205,   205,   206,
     207,   207,   207,   207,   207,   207,   208,   208,   208,   208,
     208,   209,   209,   209,   210,   211,   212,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   214,
     214,   215,   216,   216,   216,   216,   216,   216,   217,   218,
     218,   218,   218,   218,   219,   220,   220,   220,   220,   220,
     220,   221,   221,   222,   222,   223,   224,   224,   224,   224,
     224,   224,   225,   225,   226,   227,   227,   228,   228,   228,
     228,   228,   228,   229,   230,   231,   232,   233,   234,   235,
     235,   236,   236,   237,   238,   238,   239,   240,   240,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   242,
     242,   243,   244,   245,   245,   245,   246,   247,   247,   248,
     249,   249,   250,   250,   251,   251,   252,   253,   253,   254,
     254,   254,   254,   255,   256,   256,   256,   256,   256,   257,
     258,   259,   259,   260,   260,   260,   261,   261,   262,   263,
     263,   263,   264,   264,   265,   265,   266,   266,   267,   268,
     268,   268,   269,   270,   270,   270,   270,   270,   270,   270,
     271,   271,   271,   272,   272,   273,   273,   274,   274,   275,
     276,   276,   277,   277,   278,   279,   280,   281,   281,   281,
     282,   282,   283,   284,   284,   284,   284,   285,   286,   286,
     286,   287,   287,   288,   288,   289,   289,   289,   290,   290,
     290,   290,   290,   290,   291,   291,   291,   291,   291,   291,
     292,   292,   293,   293,   294,   294,   294,   294,   294,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   296,   296,   297,   298,   298,   298,   298,   298,
     298,   298,   298,   298,   298,   298,   298,   298,   299,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   301,   302,   302,   302,   303,
     303,   304,   304,   304,   305,   305,   306,   306,   306,   306,
     307,   307,   308,   308,   308,   308,   308,   309,   309,   310,
     310,   310,   310,   310,   310,   310,   310,   310,   310,   310,
     311,   311,   312,   312,   312,   312,   312,   312,   312,   313,
     313,   314,   314,   314,   314,   314,   314,   314,   314,   315,
     315,   316,   316,   316,   316,   316,   316,   316,   316,   317,
     317,   318,   318,   318,   318,   318,   319,   319,   320,   320,
     321,   321,   322,   322,   322,   323,   323,   324,   324,   324,
     324,   325,   325,   326,   326,   326,   326,   327,   327,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   329,
     329,   330,   330,   330,   331,   331,   332,   332,   332,   332,
     333,   333,   333,   333,   333,   333,   333,   334,   335,   335,
     336,   337,   337,   337,   337,   338,   339,   340,   341,   342,
     343,   343,   343,   343,   343,   343,   344,   345,   345,   346,
     347,   347,   347,   347,   347,   348,   348
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     0,     3,     5,
       2,     1,     1,     2,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     6,     2,     6,
       3,     2,     6,     6,     3,     2,     6,     2,     6,     3,
       2,     2,     2,     2,     2,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     1,     2,     0,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     0,
       1,     0,     0,     2,     2,     8,     8,     8,     0,     0,
       2,     2,     3,     3,     0,     0,     2,     2,     4,     4,
       4,     3,     1,     1,     1,     0,     0,     2,     2,     6,
       4,     4,     6,     7,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     2,     1,     2,     1,     2,     1,     0,
       2,     0,     2,     3,     0,     2,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     3,     3,     5,     1,     2,     1,
       1,     2,     2,     2,     1,     2,     1,     1,     2,     2,
       2,     2,     2,     5,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     3,     2,     1,     2,     1,     3,
       2,     1,     1,     3,     1,     2,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
       1,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     3,     1,     3,
       3,     3,     5,     1,     1,     2,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     6,     1,     1,     1,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       2,     1,     1,     1,     1,     2,     4,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, scanner, state, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, scanner, state); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, void *scanner, struct parser_state *state)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (scanner);
  YYUSE (state);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, void *scanner, struct parser_state *state)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, scanner, state);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, void *scanner, struct parser_state *state)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , scanner, state);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, scanner, state); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, void *scanner, struct parser_state *state)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (scanner);
  YYUSE (state);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 60: /* "string"  */
#line 217 "src/parser.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 2155 "src/parser.c" /* yacc.c:1257  */
        break;

    case 61: /* QUOTED_STRING  */
#line 217 "src/parser.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 2161 "src/parser.c" /* yacc.c:1257  */
        break;

    case 202: /* line  */
#line 381 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2167 "src/parser.c" /* yacc.c:1257  */
        break;

    case 203: /* base_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2173 "src/parser.c" /* yacc.c:1257  */
        break;

    case 204: /* add_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2179 "src/parser.c" /* yacc.c:1257  */
        break;

    case 205: /* create_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2185 "src/parser.c" /* yacc.c:1257  */
        break;

    case 206: /* insert_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2191 "src/parser.c" /* yacc.c:1257  */
        break;

    case 207: /* delete_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2197 "src/parser.c" /* yacc.c:1257  */
        break;

    case 208: /* list_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2203 "src/parser.c" /* yacc.c:1257  */
        break;

    case 209: /* flush_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2209 "src/parser.c" /* yacc.c:1257  */
        break;

    case 210: /* rename_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2215 "src/parser.c" /* yacc.c:1257  */
        break;

    case 211: /* export_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2221 "src/parser.c" /* yacc.c:1257  */
        break;

    case 212: /* monitor_cmd  */
#line 384 "src/parser.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 2227 "src/parser.c" /* yacc.c:1257  */
        break;

    case 215: /* table_block_alloc  */
#line 393 "src/parser.y" /* yacc.c:1257  */
      { close_scope(state); table_free(((*yyvaluep).table)); }
#line 2233 "src/parser.c" /* yacc.c:1257  */
        break;

    case 217: /* chain_block_alloc  */
#line 395 "src/parser.y" /* yacc.c:1257  */
      { close_scope(state); chain_free(((*yyvaluep).chain)); }
#line 2239 "src/parser.c" /* yacc.c:1257  */
        break;

    case 219: /* set_block_alloc  */
#line 402 "src/parser.y" /* yacc.c:1257  */
      { set_free(((*yyvaluep).set)); }
#line 2245 "src/parser.c" /* yacc.c:1257  */
        break;

    case 223: /* map_block_alloc  */
#line 405 "src/parser.y" /* yacc.c:1257  */
      { set_free(((*yyvaluep).set)); }
#line 2251 "src/parser.c" /* yacc.c:1257  */
        break;

    case 226: /* identifier  */
#line 378 "src/parser.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 2257 "src/parser.c" /* yacc.c:1257  */
        break;

    case 227: /* string  */
#line 378 "src/parser.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 2263 "src/parser.c" /* yacc.c:1257  */
        break;

    case 229: /* table_spec  */
#line 387 "src/parser.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 2269 "src/parser.c" /* yacc.c:1257  */
        break;

    case 230: /* tables_spec  */
#line 387 "src/parser.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 2275 "src/parser.c" /* yacc.c:1257  */
        break;

    case 231: /* chain_spec  */
#line 387 "src/parser.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 2281 "src/parser.c" /* yacc.c:1257  */
        break;

    case 232: /* chain_identifier  */
#line 387 "src/parser.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 2287 "src/parser.c" /* yacc.c:1257  */
        break;

    case 233: /* set_spec  */
#line 389 "src/parser.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 2293 "src/parser.c" /* yacc.c:1257  */
        break;

    case 234: /* set_identifier  */
#line 389 "src/parser.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 2299 "src/parser.c" /* yacc.c:1257  */
        break;

    case 237: /* ruleid_spec  */
#line 387 "src/parser.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 2305 "src/parser.c" /* yacc.c:1257  */
        break;

    case 238: /* comment_spec  */
#line 378 "src/parser.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 2311 "src/parser.c" /* yacc.c:1257  */
        break;

    case 239: /* rule  */
#line 397 "src/parser.y" /* yacc.c:1257  */
      { rule_free(((*yyvaluep).rule)); }
#line 2317 "src/parser.c" /* yacc.c:1257  */
        break;

    case 240: /* stmt_list  */
#line 408 "src/parser.y" /* yacc.c:1257  */
      { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 2323 "src/parser.c" /* yacc.c:1257  */
        break;

    case 241: /* stmt  */
#line 410 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2329 "src/parser.c" /* yacc.c:1257  */
        break;

    case 242: /* verdict_stmt  */
#line 410 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2335 "src/parser.c" /* yacc.c:1257  */
        break;

    case 243: /* verdict_map_stmt  */
#line 452 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2341 "src/parser.c" /* yacc.c:1257  */
        break;

    case 244: /* verdict_map_expr  */
#line 455 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2347 "src/parser.c" /* yacc.c:1257  */
        break;

    case 245: /* verdict_map_list_expr  */
#line 455 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2353 "src/parser.c" /* yacc.c:1257  */
        break;

    case 246: /* verdict_map_list_member_expr  */
#line 455 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2359 "src/parser.c" /* yacc.c:1257  */
        break;

    case 247: /* counter_stmt  */
#line 412 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2365 "src/parser.c" /* yacc.c:1257  */
        break;

    case 248: /* counter_stmt_alloc  */
#line 412 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2371 "src/parser.c" /* yacc.c:1257  */
        break;

    case 251: /* log_stmt  */
#line 418 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2377 "src/parser.c" /* yacc.c:1257  */
        break;

    case 252: /* log_stmt_alloc  */
#line 418 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2383 "src/parser.c" /* yacc.c:1257  */
        break;

    case 255: /* limit_stmt  */
#line 420 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2389 "src/parser.c" /* yacc.c:1257  */
        break;

    case 257: /* reject_stmt  */
#line 423 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2395 "src/parser.c" /* yacc.c:1257  */
        break;

    case 258: /* nat_stmt  */
#line 425 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2401 "src/parser.c" /* yacc.c:1257  */
        break;

    case 259: /* nat_stmt_alloc  */
#line 425 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2407 "src/parser.c" /* yacc.c:1257  */
        break;

    case 261: /* queue_stmt  */
#line 427 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2413 "src/parser.c" /* yacc.c:1257  */
        break;

    case 262: /* queue_stmt_alloc  */
#line 427 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2419 "src/parser.c" /* yacc.c:1257  */
        break;

    case 267: /* match_stmt  */
#line 410 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2425 "src/parser.c" /* yacc.c:1257  */
        break;

    case 268: /* symbol_expr  */
#line 431 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2431 "src/parser.c" /* yacc.c:1257  */
        break;

    case 269: /* integer_expr  */
#line 431 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2437 "src/parser.c" /* yacc.c:1257  */
        break;

    case 270: /* primary_expr  */
#line 433 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2443 "src/parser.c" /* yacc.c:1257  */
        break;

    case 271: /* shift_expr  */
#line 433 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2449 "src/parser.c" /* yacc.c:1257  */
        break;

    case 272: /* and_expr  */
#line 433 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2455 "src/parser.c" /* yacc.c:1257  */
        break;

    case 273: /* exclusive_or_expr  */
#line 435 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2461 "src/parser.c" /* yacc.c:1257  */
        break;

    case 274: /* inclusive_or_expr  */
#line 435 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2467 "src/parser.c" /* yacc.c:1257  */
        break;

    case 275: /* basic_expr  */
#line 437 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2473 "src/parser.c" /* yacc.c:1257  */
        break;

    case 276: /* concat_expr  */
#line 446 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2479 "src/parser.c" /* yacc.c:1257  */
        break;

    case 277: /* list_expr  */
#line 444 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2485 "src/parser.c" /* yacc.c:1257  */
        break;

    case 278: /* prefix_expr  */
#line 442 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2491 "src/parser.c" /* yacc.c:1257  */
        break;

    case 279: /* range_expr  */
#line 442 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2497 "src/parser.c" /* yacc.c:1257  */
        break;

    case 280: /* wildcard_expr  */
#line 442 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2503 "src/parser.c" /* yacc.c:1257  */
        break;

    case 281: /* multiton_expr  */
#line 440 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2509 "src/parser.c" /* yacc.c:1257  */
        break;

    case 282: /* map_lhs_expr  */
#line 446 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2515 "src/parser.c" /* yacc.c:1257  */
        break;

    case 283: /* map_expr  */
#line 449 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2521 "src/parser.c" /* yacc.c:1257  */
        break;

    case 284: /* expr  */
#line 461 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2527 "src/parser.c" /* yacc.c:1257  */
        break;

    case 285: /* set_expr  */
#line 458 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2533 "src/parser.c" /* yacc.c:1257  */
        break;

    case 286: /* set_list_expr  */
#line 458 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2539 "src/parser.c" /* yacc.c:1257  */
        break;

    case 287: /* set_list_member_expr  */
#line 458 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2545 "src/parser.c" /* yacc.c:1257  */
        break;

    case 288: /* initializer_expr  */
#line 461 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2551 "src/parser.c" /* yacc.c:1257  */
        break;

    case 289: /* relational_expr  */
#line 464 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2557 "src/parser.c" /* yacc.c:1257  */
        break;

    case 291: /* verdict_expr  */
#line 431 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2563 "src/parser.c" /* yacc.c:1257  */
        break;

    case 292: /* meta_expr  */
#line 505 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2569 "src/parser.c" /* yacc.c:1257  */
        break;

    case 296: /* meta_stmt  */
#line 416 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2575 "src/parser.c" /* yacc.c:1257  */
        break;

    case 297: /* ct_expr  */
#line 509 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2581 "src/parser.c" /* yacc.c:1257  */
        break;

    case 299: /* ct_stmt  */
#line 414 "src/parser.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 2587 "src/parser.c" /* yacc.c:1257  */
        break;

    case 300: /* payload_expr  */
#line 468 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2593 "src/parser.c" /* yacc.c:1257  */
        break;

    case 301: /* payload_raw_expr  */
#line 468 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2599 "src/parser.c" /* yacc.c:1257  */
        break;

    case 303: /* eth_hdr_expr  */
#line 471 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2605 "src/parser.c" /* yacc.c:1257  */
        break;

    case 305: /* vlan_hdr_expr  */
#line 471 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2611 "src/parser.c" /* yacc.c:1257  */
        break;

    case 307: /* arp_hdr_expr  */
#line 474 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2617 "src/parser.c" /* yacc.c:1257  */
        break;

    case 309: /* ip_hdr_expr  */
#line 477 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2623 "src/parser.c" /* yacc.c:1257  */
        break;

    case 311: /* icmp_hdr_expr  */
#line 477 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2629 "src/parser.c" /* yacc.c:1257  */
        break;

    case 313: /* ip6_hdr_expr  */
#line 480 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2635 "src/parser.c" /* yacc.c:1257  */
        break;

    case 315: /* icmp6_hdr_expr  */
#line 480 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2641 "src/parser.c" /* yacc.c:1257  */
        break;

    case 317: /* auth_hdr_expr  */
#line 483 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2647 "src/parser.c" /* yacc.c:1257  */
        break;

    case 319: /* esp_hdr_expr  */
#line 483 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2653 "src/parser.c" /* yacc.c:1257  */
        break;

    case 321: /* comp_hdr_expr  */
#line 483 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2659 "src/parser.c" /* yacc.c:1257  */
        break;

    case 323: /* udp_hdr_expr  */
#line 486 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2665 "src/parser.c" /* yacc.c:1257  */
        break;

    case 325: /* udplite_hdr_expr  */
#line 486 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2671 "src/parser.c" /* yacc.c:1257  */
        break;

    case 327: /* tcp_hdr_expr  */
#line 486 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2677 "src/parser.c" /* yacc.c:1257  */
        break;

    case 329: /* dccp_hdr_expr  */
#line 489 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2683 "src/parser.c" /* yacc.c:1257  */
        break;

    case 331: /* sctp_hdr_expr  */
#line 489 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2689 "src/parser.c" /* yacc.c:1257  */
        break;

    case 333: /* exthdr_expr  */
#line 493 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2695 "src/parser.c" /* yacc.c:1257  */
        break;

    case 334: /* hbh_hdr_expr  */
#line 495 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2701 "src/parser.c" /* yacc.c:1257  */
        break;

    case 336: /* rt_hdr_expr  */
#line 498 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2707 "src/parser.c" /* yacc.c:1257  */
        break;

    case 338: /* rt0_hdr_expr  */
#line 498 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2713 "src/parser.c" /* yacc.c:1257  */
        break;

    case 340: /* rt2_hdr_expr  */
#line 498 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2719 "src/parser.c" /* yacc.c:1257  */
        break;

    case 342: /* frag_hdr_expr  */
#line 495 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2725 "src/parser.c" /* yacc.c:1257  */
        break;

    case 344: /* dst_hdr_expr  */
#line 495 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2731 "src/parser.c" /* yacc.c:1257  */
        break;

    case 346: /* mh_hdr_expr  */
#line 501 "src/parser.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 2737 "src/parser.c" /* yacc.c:1257  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void *scanner, struct parser_state *state)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

/* User initialization code.  */
#line 123 "src/parser.y" /* yacc.c:1429  */
{
	location_init(scanner, state, &yylloc);
#ifdef DEBUG
	if (debug_level & DEBUG_SCANNER)
		nft_set_debug(1, scanner);
	if (debug_level & DEBUG_PARSER)
		yydebug = 1;
#endif
}

#line 2856 "src/parser.c" /* yacc.c:1429  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 518 "src/parser.y" /* yacc.c:1646  */
    {
				if ((yyvsp[0].cmd) != NULL) {
					LIST_HEAD(list);

					(yyvsp[0].cmd)->location = (yylsp[0]);

					list_add_tail(&(yyvsp[0].cmd)->list, &list);
					if (cmd_evaluate(&state->ectx, (yyvsp[0].cmd)) < 0) {
						if (++state->nerrs == max_errors)
							YYABORT;
					} else
						list_splice_tail(&list, &state->cmds);
				}
			}
#line 3058 "src/parser.c" /* yacc.c:1646  */
    break;

  case 8:
#line 543 "src/parser.y" /* yacc.c:1646  */
    {
				if (scanner_include_file(scanner, (yyvsp[-1].string), &(yyloc)) < 0) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 3070 "src/parser.c" /* yacc.c:1646  */
    break;

  case 9:
#line 551 "src/parser.y" /* yacc.c:1646  */
    {
				struct scope *scope = current_scope(state);

				if (symbol_lookup(scope, (yyvsp[-3].string)) != NULL) {
					erec_queue(error(&(yylsp[-3]), "redfinition of symbol '%s'", (yyvsp[-3].string)),
						   state->msgs);
					YYERROR;
				}

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 3087 "src/parser.c" /* yacc.c:1646  */
    break;

  case 10:
#line 564 "src/parser.y" /* yacc.c:1646  */
    {
				if (++state->nerrs == max_errors)
					YYABORT;
				yyerrok;
			}
#line 3097 "src/parser.c" /* yacc.c:1646  */
    break;

  case 11:
#line 571 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = NULL; }
#line 3103 "src/parser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 572 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = NULL; }
#line 3109 "src/parser.c" /* yacc.c:1646  */
    break;

  case 13:
#line 573 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[-1].cmd); }
#line 3115 "src/parser.c" /* yacc.c:1646  */
    break;

  case 14:
#line 575 "src/parser.y" /* yacc.c:1646  */
    {
				/*
				 * Very hackish workaround for bison >= 2.4: previous versions
				 * terminated parsing after EOF, 2.4+ tries to get further input
				 * in 'input' and calls the scanner again, causing a crash when
				 * the final input buffer has been popped. Terminate manually to
				 * avoid this. The correct fix should be to adjust the grammar
				 * to accept EOF in input, but for unknown reasons it does not
				 * work.
				 */
				if ((yyvsp[-1].cmd) != NULL) {
					LIST_HEAD(list);

					(yyvsp[-1].cmd)->location = (yylsp[-1]);

					list_add_tail(&(yyvsp[-1].cmd)->list, &list);
					if (cmd_evaluate(&state->ectx, (yyvsp[-1].cmd)) < 0) {
						if (++state->nerrs == max_errors)
							YYABORT;
					} else
						list_splice_tail(&list, &state->cmds);
				}
				(yyval.cmd) = NULL;

				YYACCEPT;
			}
#line 3146 "src/parser.c" /* yacc.c:1646  */
    break;

  case 15:
#line 603 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3152 "src/parser.c" /* yacc.c:1646  */
    break;

  case 16:
#line 604 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3158 "src/parser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 605 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3164 "src/parser.c" /* yacc.c:1646  */
    break;

  case 18:
#line 606 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3170 "src/parser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 607 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3176 "src/parser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 608 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3182 "src/parser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 609 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3188 "src/parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 610 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3194 "src/parser.c" /* yacc.c:1646  */
    break;

  case 23:
#line 611 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3200 "src/parser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 612 "src/parser.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 3206 "src/parser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 614 "src/parser.y" /* yacc.c:1646  */
    {
				expr_describe((yyvsp[0].expr));
				expr_free((yyvsp[0].expr));
				(yyval.cmd) = NULL;
			}
#line 3216 "src/parser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 622 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3224 "src/parser.c" /* yacc.c:1646  */
    break;

  case 27:
#line 627 "src/parser.y" /* yacc.c:1646  */
    {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 3234 "src/parser.c" /* yacc.c:1646  */
    break;

  case 28:
#line 633 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3242 "src/parser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 638 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 3253 "src/parser.c" /* yacc.c:1646  */
    break;

  case 30:
#line 645 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 3261 "src/parser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 649 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 3269 "src/parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 654 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 3279 "src/parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 661 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 3289 "src/parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 667 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SETELEM, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 3297 "src/parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 673 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3305 "src/parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 678 "src/parser.y" /* yacc.c:1646  */
    {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 3315 "src/parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 684 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3323 "src/parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 689 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 3334 "src/parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 698 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_INSERT, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 3342 "src/parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 704 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3350 "src/parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 708 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3358 "src/parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 712 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_RULE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3366 "src/parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 716 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3374 "src/parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 720 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3382 "src/parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 724 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SETELEM, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 3390 "src/parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 730 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3398 "src/parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 734 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3406 "src/parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 738 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3414 "src/parser.c" /* yacc.c:1646  */
    break;

  case 49:
#line 742 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3422 "src/parser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 746 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3430 "src/parser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 752 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3438 "src/parser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 756 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3446 "src/parser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 760 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 3454 "src/parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 766 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RENAME, CMD_OBJ_CHAIN, &(yyvsp[-1].handle), &(yyloc), NULL);
				(yyval.cmd)->arg = (yyvsp[0].string);
			}
#line 3463 "src/parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 773 "src/parser.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_RULESET, &h, &(yyloc), NULL);
				(yyval.cmd)->format = (yyvsp[0].val);
			}
#line 3473 "src/parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 781 "src/parser.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				(yyval.cmd) = cmd_alloc(CMD_MONITOR, CMD_OBJ_RULESET, &h, &(yyloc), NULL);
				(yyval.cmd)->monitor_flags = (yyvsp[-1].val);
				(yyval.cmd)->format = (yyvsp[0].val);
			}
#line 3484 "src/parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 790 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (1 << NFT_MSG_NEWRULE)	|
				     (1 << NFT_MSG_DELRULE)	|
				     (1 << NFT_MSG_NEWSET)	|
				     (1 << NFT_MSG_DELSET)	|
				     (1 << NFT_MSG_NEWSETELEM)	|
				     (1 << NFT_MSG_DELSETELEM)	|
				     (1 << NFT_MSG_NEWCHAIN)	|
				     (1 << NFT_MSG_DELCHAIN)	|
				     (1 << NFT_MSG_NEWTABLE)	|
				     (1 << NFT_MSG_DELTABLE);
			}
#line 3501 "src/parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 803 "src/parser.y" /* yacc.c:1646  */
    {
				int event;

				event = monitor_lookup_event((yyvsp[0].string));
				if (event < 0) {
					erec_queue(error(&(yylsp[0]), "unknown event type %s", (yyvsp[0].string)),
						   state->msgs);
					YYERROR;
				}

				switch (event) {
				case NFT_EVENT_NEW:
					(yyval.val) = (1 << NFT_MSG_NEWTABLE)	|
					     (1 << NFT_MSG_NEWCHAIN)	|
					     (1 << NFT_MSG_NEWRULE)	|
					     (1 << NFT_MSG_NEWSET)	|
					     (1 << NFT_MSG_NEWSETELEM);
					break;
				case NFT_EVENT_DEL:
					(yyval.val) = (1 << NFT_MSG_DELTABLE)	|
					     (1 << NFT_MSG_DELCHAIN)	|
					     (1 << NFT_MSG_DELRULE)	|
					     (1 << NFT_MSG_DELSET)	|
					     (1 << NFT_MSG_DELSETELEM);
					break;
				}
			}
#line 3533 "src/parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 831 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (1 << NFT_MSG_NEWTABLE) |
				     (1 << NFT_MSG_DELTABLE);
			}
#line 3542 "src/parser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 836 "src/parser.y" /* yacc.c:1646  */
    {
				int event;

				event = monitor_lookup_event((yyvsp[-1].string));
				if (event < 0) {
					erec_queue(error(&(yylsp[-1]), "unknown event type %s", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}

				switch (event) {
				case NFT_EVENT_NEW:
					(yyval.val) = (1 << NFT_MSG_NEWTABLE);
					break;
				case NFT_EVENT_DEL:
					(yyval.val) = (1 << NFT_MSG_DELTABLE);
					break;
				}
			}
#line 3566 "src/parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 856 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (1 << NFT_MSG_NEWCHAIN) |
				     (1 << NFT_MSG_DELCHAIN);
			}
#line 3575 "src/parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 861 "src/parser.y" /* yacc.c:1646  */
    {
				int event;

				event = monitor_lookup_event((yyvsp[-1].string));
				if (event < 0) {
					erec_queue(error(&(yylsp[-1]), "unknown event type %s", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}

				switch (event) {
				case NFT_EVENT_NEW:
					(yyval.val) = (1 << NFT_MSG_NEWCHAIN);
					break;
				case NFT_EVENT_DEL:
					(yyval.val) = (1 << NFT_MSG_DELCHAIN);
					break;
				}
			}
#line 3599 "src/parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 881 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (1 << NFT_MSG_NEWSET) |
				     (1 << NFT_MSG_DELSET);
			}
#line 3608 "src/parser.c" /* yacc.c:1646  */
    break;

  case 64:
#line 886 "src/parser.y" /* yacc.c:1646  */
    {
				int event;

				event = monitor_lookup_event((yyvsp[-1].string));
				if (event < 0) {
					erec_queue(error(&(yylsp[-1]), "unknown event type %s", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}

				switch (event) {
				case NFT_EVENT_NEW:
					(yyval.val) = (1 << NFT_MSG_NEWSET);
					break;
				case NFT_EVENT_DEL:
					(yyval.val) = (1 << NFT_MSG_DELSET);
					break;
				}
			}
#line 3632 "src/parser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 906 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (1 << NFT_MSG_NEWRULE) |
				     (1 << NFT_MSG_DELRULE);
			}
#line 3641 "src/parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 911 "src/parser.y" /* yacc.c:1646  */
    {
				int event;

				event = monitor_lookup_event((yyvsp[-1].string));
				if (event < 0) {
					erec_queue(error(&(yylsp[-1]), "unknown event type %s", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}

				switch (event) {
				case NFT_EVENT_NEW:
					(yyval.val) = (1 << NFT_MSG_NEWRULE);
					break;
				case NFT_EVENT_DEL:
					(yyval.val) = (1 << NFT_MSG_DELRULE);
					break;
				}
			}
#line 3665 "src/parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 931 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (1 << NFT_MSG_NEWSETELEM) |
				     (1 << NFT_MSG_DELSETELEM);
			}
#line 3674 "src/parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 936 "src/parser.y" /* yacc.c:1646  */
    {
				int event;

				event = monitor_lookup_event((yyvsp[-1].string));
				if (event < 0) {
					erec_queue(error(&(yylsp[-1]), "unknown event type %s", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}

				switch (event) {
				case NFT_EVENT_NEW:
					(yyval.val) = (1 << NFT_MSG_NEWSETELEM);
					break;
				case NFT_EVENT_DEL:
					(yyval.val) = (1 << NFT_MSG_DELSETELEM);
					break;
				}
			}
#line 3698 "src/parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 958 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = NFT_OUTPUT_DEFAULT;
			}
#line 3706 "src/parser.c" /* yacc.c:1646  */
    break;

  case 71:
#line 965 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.table) = table_alloc();
				open_scope(state, &(yyval.table)->scope);
			}
#line 3715 "src/parser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 971 "src/parser.y" /* yacc.c:1646  */
    { (yyval.table) = (yyvsp[(-1) - (0)].table); }
#line 3721 "src/parser.c" /* yacc.c:1646  */
    break;

  case 75:
#line 977 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].chain)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].chain)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				close_scope(state);
				list_add_tail(&(yyvsp[-4].chain)->list, &(yyvsp[-7].table)->chains);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 3734 "src/parser.c" /* yacc.c:1646  */
    break;

  case 76:
#line 988 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 3746 "src/parser.c" /* yacc.c:1646  */
    break;

  case 77:
#line 998 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 3758 "src/parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1008 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.chain) = chain_alloc(NULL);
				open_scope(state, &(yyval.chain)->scope);
			}
#line 3767 "src/parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1014 "src/parser.y" /* yacc.c:1646  */
    { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 3773 "src/parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1019 "src/parser.y" /* yacc.c:1646  */
    {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 3782 "src/parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1026 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.set) = set_alloc(NULL);
			}
#line 3790 "src/parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1031 "src/parser.y" /* yacc.c:1646  */
    { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 3796 "src/parser.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1035 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->keytype = datatype_lookup_byname((yyvsp[-1].string));
				if ((yyvsp[-3].set)->keytype == NULL) {
					erec_queue(error(&(yylsp[-1]), "unknown datatype %s", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}
				(yyval.set) = (yyvsp[-3].set);
			}
#line 3810 "src/parser.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1045 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->flags = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 3819 "src/parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1050 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 3828 "src/parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1057 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 3836 "src/parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1063 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = SET_F_CONSTANT; }
#line 3842 "src/parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1064 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = SET_F_INTERVAL; }
#line 3848 "src/parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1068 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.set) = set_alloc(NULL);
				(yyval.set)->flags |= NFT_SET_MAP;
			}
#line 3857 "src/parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1074 "src/parser.y" /* yacc.c:1646  */
    { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 3863 "src/parser.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1080 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-5].set)->keytype = datatype_lookup_byname((yyvsp[-3].string));
				if ((yyvsp[-5].set)->keytype == NULL) {
					erec_queue(error(&(yylsp[-3]), "unknown datatype %s", (yyvsp[-3].string)),
						   state->msgs);
					YYERROR;
				}

				(yyvsp[-5].set)->datatype = datatype_lookup_byname((yyvsp[-1].string));
				if ((yyvsp[-5].set)->datatype == NULL) {
					erec_queue(error(&(yylsp[-1]), "unknown datatype %s", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}

				(yyval.set) = (yyvsp[-5].set);
			}
#line 3885 "src/parser.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1098 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->flags = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 3894 "src/parser.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1103 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 3903 "src/parser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1110 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-6].chain)->type		= chain_type_name_lookup((yyvsp[-4].string));
				if ((yyvsp[-6].chain)->type == NULL) {
					erec_queue(error(&(yylsp[-4]), "unknown chain type %s", (yyvsp[-4].string)),
						   state->msgs);
					YYERROR;
				}
				(yyvsp[-6].chain)->hookstr	= chain_hookname_lookup((yyvsp[-2].string));
				if ((yyvsp[-6].chain)->hookstr == NULL) {
					erec_queue(error(&(yylsp[-2]), "unknown chain type %s", (yyvsp[-2].string)),
						   state->msgs);
					YYERROR;
				}
				(yyvsp[-6].chain)->priority	= (yyvsp[0].val);
				(yyvsp[-6].chain)->flags	|= CHAIN_F_BASECHAIN;
			}
#line 3924 "src/parser.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1127 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-7].chain)->type		= chain_type_name_lookup((yyvsp[-5].string));
				if ((yyvsp[-7].chain)->type == NULL) {
					erec_queue(error(&(yylsp[-5]), "unknown type name %s", (yyvsp[-5].string)),
						   state->msgs);
					YYERROR;
				}
				(yyvsp[-7].chain)->hookstr	= chain_hookname_lookup((yyvsp[-3].string));
				if ((yyvsp[-7].chain)->hookstr == NULL) {
					erec_queue(error(&(yylsp[-3]), "unknown hook name %s", (yyvsp[-3].string)),
						   state->msgs);
					YYERROR;
				}
				(yyvsp[-7].chain)->priority	= -(yyvsp[0].val);
				(yyvsp[-7].chain)->flags	|= CHAIN_F_BASECHAIN;
			}
#line 3945 "src/parser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1152 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV4; }
#line 3951 "src/parser.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1153 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV4; }
#line 3957 "src/parser.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1154 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV6; }
#line 3963 "src/parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1155 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_INET; }
#line 3969 "src/parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1156 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_ARP; }
#line 3975 "src/parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1157 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_BRIDGE; }
#line 3981 "src/parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1161 "src/parser.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[-1].val);
				(yyval.handle).table	= (yyvsp[0].string);
			}
#line 3991 "src/parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1169 "src/parser.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[0].val);
				(yyval.handle).table	= NULL;
			}
#line 4001 "src/parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1177 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).chain	= (yyvsp[0].string);
			}
#line 4010 "src/parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1184 "src/parser.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).chain	= (yyvsp[0].string);
			}
#line 4019 "src/parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1191 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).set		= (yyvsp[0].string);
			}
#line 4028 "src/parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1198 "src/parser.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).set		= (yyvsp[0].string);
			}
#line 4037 "src/parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1205 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = 0;
			}
#line 4045 "src/parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1209 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[0].val);
			}
#line 4053 "src/parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1215 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = 0;
			}
#line 4061 "src/parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1219 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[0].val);
			}
#line 4069 "src/parser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1225 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.handle)		= (yyvsp[-2].handle);
				(yyval.handle).handle	= (yyvsp[-1].val);
				(yyval.handle).position	= (yyvsp[0].val);
			}
#line 4079 "src/parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1233 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.string) = NULL;
			}
#line 4087 "src/parser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1237 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.string) = (yyvsp[0].string);
			}
#line 4095 "src/parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1243 "src/parser.y" /* yacc.c:1646  */
    {
				struct stmt *i;

				(yyval.rule) = rule_alloc(&(yyloc), NULL);
				(yyval.rule)->handle.comment = (yyvsp[0].string);
				list_for_each_entry(i, (yyvsp[-1].list), list)
					(yyval.rule)->num_stmts++;
				list_splice_tail((yyvsp[-1].list), &(yyval.rule)->stmts);
				xfree((yyvsp[-1].list));
			}
#line 4110 "src/parser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1256 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 4120 "src/parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1262 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 4129 "src/parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1281 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 4137 "src/parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1285 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 4145 "src/parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1291 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4153 "src/parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1297 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 4162 "src/parser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1304 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = set_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 4171 "src/parser.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1309 "src/parser.y" /* yacc.c:1646  */
    {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 4180 "src/parser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1317 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 4188 "src/parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1327 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 4196 "src/parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1333 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 4204 "src/parser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1340 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->counter.packets = (yyvsp[0].val);
			}
#line 4212 "src/parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1344 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->counter.bytes	 = (yyvsp[0].val);
			}
#line 4220 "src/parser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1354 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = log_stmt_alloc(&(yyloc));
			}
#line 4228 "src/parser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1360 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 4236 "src/parser.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1367 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.prefix	 = (yyvsp[0].string);
			}
#line 4244 "src/parser.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1371 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.group	 = (yyvsp[0].val);
			}
#line 4252 "src/parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1375 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.snaplen	 = (yyvsp[0].val);
			}
#line 4260 "src/parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1379 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.qthreshold = (yyvsp[0].val);
			}
#line 4268 "src/parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1385 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= (yyvsp[-2].val);
				(yyval.stmt)->limit.unit	= (yyvsp[0].val);
			}
#line 4278 "src/parser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1392 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL; }
#line 4284 "src/parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1393 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60; }
#line 4290 "src/parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1394 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60 * 60; }
#line 4296 "src/parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1395 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60 * 60 * 24; }
#line 4302 "src/parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1396 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60 * 60 * 24 * 7; }
#line 4308 "src/parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1400 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = reject_stmt_alloc(&(yyloc));
			}
#line 4316 "src/parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1409 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = nat_stmt_alloc(&(yyloc));
				(yyval.stmt)->nat.type = NFT_NAT_SNAT;
			}
#line 4325 "src/parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1414 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = nat_stmt_alloc(&(yyloc));
				(yyval.stmt)->nat.type = NFT_NAT_DNAT;
			}
#line 4334 "src/parser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1421 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 4342 "src/parser.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1425 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 4351 "src/parser.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1430 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 4359 "src/parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1440 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc));
			}
#line 4367 "src/parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1446 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->queue.from = (yyvsp[-1].stmt)->queue.from;
				(yyvsp[-3].stmt)->queue.to = (yyvsp[-1].stmt)->queue.to;
				(yyvsp[-3].stmt)->queue.flags = (yyvsp[0].val);
			}
#line 4377 "src/parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1452 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->queue.from = (yyvsp[0].stmt)->queue.from;
				(yyvsp[-2].stmt)->queue.to = (yyvsp[0].stmt)->queue.to;
			}
#line 4386 "src/parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1457 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].stmt)->queue.flags = (yyvsp[0].val);
			}
#line 4394 "src/parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1463 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].stmt)->queue.from = (yyvsp[0].val);
				(yyvsp[-1].stmt)->queue.to = (yyvsp[0].val);
				(yyval.stmt) = (yyvsp[-1].stmt);
			}
#line 4404 "src/parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1469 "src/parser.y" /* yacc.c:1646  */
    {
				if ((yyvsp[0].val) < (yyvsp[-2].val)) {
					erec_queue(error(&(yylsp[-2]),
							 "invalid range %d-%d",
							 (yyvsp[-2].val), (yyvsp[0].val)), state->msgs);
					YYERROR;
				}
				(yyvsp[-3].stmt)->queue.from = (yyvsp[-2].val);
				(yyvsp[-3].stmt)->queue.to = (yyvsp[0].val);
				(yyval.stmt) = (yyvsp[-3].stmt);
			}
#line 4420 "src/parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1483 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[0].val);
			}
#line 4428 "src/parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1487 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) |= (yyvsp[-1].val) | (yyvsp[0].val);
			}
#line 4436 "src/parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1493 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = NFT_QUEUE_FLAG_BYPASS;
			}
#line 4444 "src/parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1497 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = NFT_QUEUE_FLAG_CPU_FANOUT;
			}
#line 4452 "src/parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1503 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = expr_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 4460 "src/parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1509 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 4471 "src/parser.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1516 "src/parser.y" /* yacc.c:1646  */
    {
				struct scope *scope = current_scope(state);

				if (symbol_lookup(scope, (yyvsp[0].string)) == NULL) {
					erec_queue(error(&(yylsp[0]), "unknown identifier '%s'", (yyvsp[0].string)),
						   state->msgs);
					YYERROR;
				}

				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_DEFINE,
						       scope, (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 4489 "src/parser.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1530 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_SET,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 4500 "src/parser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1539 "src/parser.y" /* yacc.c:1646  */
    {
				char str[64];

				snprintf(str, sizeof(str), "%" PRIu64, (yyvsp[0].val));
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       str);
			}
#line 4513 "src/parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1549 "src/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4519 "src/parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1550 "src/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4525 "src/parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1551 "src/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4531 "src/parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1552 "src/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4537 "src/parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1553 "src/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4543 "src/parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1554 "src/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4549 "src/parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1555 "src/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 4555 "src/parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1560 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4563 "src/parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1564 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4571 "src/parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1571 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4579 "src/parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1578 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4587 "src/parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1585 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4595 "src/parser.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1595 "src/parser.y" /* yacc.c:1646  */
    {
				if ((yyval.expr)->ops->type != EXPR_CONCAT) {
					(yyval.expr) = concat_expr_alloc(&(yyloc));
					compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				} else {
					struct location rhs[] = {
						[1]	= (yylsp[-1]),
						[2]	= (yylsp[0]),
					};
					location_update(&(yyvsp[0].expr)->location, rhs, 2);

					(yyval.expr) = (yyvsp[-2].expr);
					(yyval.expr)->location = (yyloc);
				}
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 4616 "src/parser.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1614 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 4626 "src/parser.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1620 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 4636 "src/parser.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1628 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 4644 "src/parser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1634 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4652 "src/parser.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1640 "src/parser.y" /* yacc.c:1646  */
    {
				struct expr *expr;

				expr = constant_expr_alloc(&(yyloc), &integer_type,
							   BYTEORDER_HOST_ENDIAN,
							   0, NULL);
				(yyval.expr) = prefix_expr_alloc(&(yyloc), expr, 0);
			}
#line 4665 "src/parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1660 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4673 "src/parser.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1672 "src/parser.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 4682 "src/parser.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1679 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = set_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 4691 "src/parser.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1684 "src/parser.y" /* yacc.c:1646  */
    {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 4700 "src/parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1692 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 4708 "src/parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1696 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 4716 "src/parser.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1706 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 4724 "src/parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1710 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_FLAGCMP, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 4732 "src/parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1714 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = relational_expr_alloc(&(yylsp[-1]), (yyvsp[-1].val), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 4740 "src/parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1719 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = OP_EQ; }
#line 4746 "src/parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1720 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = OP_NEQ; }
#line 4752 "src/parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1721 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = OP_LT; }
#line 4758 "src/parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1722 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = OP_GT; }
#line 4764 "src/parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1723 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = OP_GTE; }
#line 4770 "src/parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1724 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = OP_LTE; }
#line 4776 "src/parser.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1728 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_ACCEPT, NULL);
			}
#line 4784 "src/parser.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1732 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_DROP, NULL);
			}
#line 4792 "src/parser.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1736 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_CONTINUE, NULL);
			}
#line 4800 "src/parser.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1740 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_JUMP, (yyvsp[0].string));
			}
#line 4808 "src/parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1744 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_GOTO, (yyvsp[0].string));
			}
#line 4816 "src/parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1748 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_RETURN, NULL);
			}
#line 4824 "src/parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1754 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 4832 "src/parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1758 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 4840 "src/parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1767 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_LEN; }
#line 4846 "src/parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1768 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_NFPROTO; }
#line 4852 "src/parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1769 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_L4PROTO; }
#line 4858 "src/parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1770 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_PROTOCOL; }
#line 4864 "src/parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1771 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_PRIORITY; }
#line 4870 "src/parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1774 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_MARK; }
#line 4876 "src/parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1775 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_IIF; }
#line 4882 "src/parser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1776 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_IIFNAME; }
#line 4888 "src/parser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1777 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_IIFTYPE; }
#line 4894 "src/parser.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1778 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_OIF; }
#line 4900 "src/parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1779 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_OIFNAME; }
#line 4906 "src/parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1780 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_OIFTYPE; }
#line 4912 "src/parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1781 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_SKUID; }
#line 4918 "src/parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1782 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_SKGID; }
#line 4924 "src/parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1783 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_NFTRACE; }
#line 4930 "src/parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1784 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_RTCLASSID; }
#line 4936 "src/parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1785 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 4942 "src/parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1786 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 4948 "src/parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1790 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 4956 "src/parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1794 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 4964 "src/parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1800 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 4972 "src/parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1805 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_STATE; }
#line 4978 "src/parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1806 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_DIRECTION; }
#line 4984 "src/parser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1807 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_STATUS; }
#line 4990 "src/parser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1808 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_MARK; }
#line 4996 "src/parser.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1809 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_EXPIRATION; }
#line 5002 "src/parser.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1810 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_HELPER; }
#line 5008 "src/parser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1811 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 5014 "src/parser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1812 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_SRC; }
#line 5020 "src/parser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1813 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_DST; }
#line 5026 "src/parser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1814 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTOCOL; }
#line 5032 "src/parser.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1815 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 5038 "src/parser.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1816 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTO_DST; }
#line 5044 "src/parser.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1817 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_LABEL; }
#line 5050 "src/parser.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1821 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 5058 "src/parser.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1845 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), NULL, 0);
				(yyval.expr)->payload.base	= (yyvsp[-4].val);
				(yyval.expr)->payload.offset	= (yyvsp[-2].val);
				(yyval.expr)->len			= (yyvsp[0].val);
				(yyval.expr)->dtype		= &integer_type;
			}
#line 5070 "src/parser.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1854 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = PROTO_BASE_LL_HDR; }
#line 5076 "src/parser.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1855 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = PROTO_BASE_NETWORK_HDR; }
#line 5082 "src/parser.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1856 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = PROTO_BASE_TRANSPORT_HDR; }
#line 5088 "src/parser.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1860 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_eth, (yyvsp[0].val));
			}
#line 5096 "src/parser.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1864 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       "ether");
			}
#line 5106 "src/parser.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1871 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ETHHDR_SADDR; }
#line 5112 "src/parser.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1872 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ETHHDR_DADDR; }
#line 5118 "src/parser.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1873 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ETHHDR_TYPE; }
#line 5124 "src/parser.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1877 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_vlan, (yyvsp[0].val));
			}
#line 5132 "src/parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1881 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       "vlan");
			}
#line 5142 "src/parser.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1888 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_VID; }
#line 5148 "src/parser.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1889 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_CFI; }
#line 5154 "src/parser.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1890 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_PCP; }
#line 5160 "src/parser.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1891 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_TYPE; }
#line 5166 "src/parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1895 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_arp, (yyvsp[0].val));
			}
#line 5174 "src/parser.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1899 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       "arp");
			}
#line 5184 "src/parser.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1906 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_HRD; }
#line 5190 "src/parser.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1907 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_PRO; }
#line 5196 "src/parser.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1908 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_HLN; }
#line 5202 "src/parser.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1909 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_PLN; }
#line 5208 "src/parser.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1910 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_OP; }
#line 5214 "src/parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1914 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip, (yyvsp[0].val));
			}
#line 5222 "src/parser.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1918 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       "ip");
			}
#line 5232 "src/parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1925 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_VERSION; }
#line 5238 "src/parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1926 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_HDRLENGTH; }
#line 5244 "src/parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1927 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_TOS; }
#line 5250 "src/parser.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1928 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_LENGTH; }
#line 5256 "src/parser.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1929 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_ID; }
#line 5262 "src/parser.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1930 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_FRAG_OFF; }
#line 5268 "src/parser.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1931 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_TTL; }
#line 5274 "src/parser.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1932 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_PROTOCOL; }
#line 5280 "src/parser.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1933 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_CHECKSUM; }
#line 5286 "src/parser.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1934 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_SADDR; }
#line 5292 "src/parser.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1935 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_DADDR; }
#line 5298 "src/parser.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1939 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp, (yyvsp[0].val));
			}
#line 5306 "src/parser.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1943 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_ICMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5317 "src/parser.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1951 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_TYPE; }
#line 5323 "src/parser.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1952 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_CODE; }
#line 5329 "src/parser.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1953 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_CHECKSUM; }
#line 5335 "src/parser.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1954 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_ID; }
#line 5341 "src/parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1955 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_SEQ; }
#line 5347 "src/parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1956 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_GATEWAY; }
#line 5353 "src/parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1957 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_MTU; }
#line 5359 "src/parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1961 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip6, (yyvsp[0].val));
			}
#line 5367 "src/parser.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1965 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       "ip6");
			}
#line 5377 "src/parser.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1972 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_VERSION; }
#line 5383 "src/parser.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1973 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_PRIORITY; }
#line 5389 "src/parser.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1974 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_FLOWLABEL; }
#line 5395 "src/parser.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1975 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_LENGTH; }
#line 5401 "src/parser.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1976 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_NEXTHDR; }
#line 5407 "src/parser.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1977 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_HOPLIMIT; }
#line 5413 "src/parser.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1978 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_SADDR; }
#line 5419 "src/parser.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1979 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_DADDR; }
#line 5425 "src/parser.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1982 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp6, (yyvsp[0].val));
			}
#line 5433 "src/parser.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1986 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_ICMPV6;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5444 "src/parser.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1994 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_TYPE; }
#line 5450 "src/parser.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1995 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_CODE; }
#line 5456 "src/parser.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1996 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_CHECKSUM; }
#line 5462 "src/parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1997 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_PPTR; }
#line 5468 "src/parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1998 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_MTU; }
#line 5474 "src/parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1999 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_ID; }
#line 5480 "src/parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2000 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_SEQ; }
#line 5486 "src/parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2001 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_MAXDELAY; }
#line 5492 "src/parser.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2005 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ah, (yyvsp[0].val));
			}
#line 5500 "src/parser.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2009 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_AH;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5511 "src/parser.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2017 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_NEXTHDR; }
#line 5517 "src/parser.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2018 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_HDRLENGTH; }
#line 5523 "src/parser.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2019 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_RESERVED; }
#line 5529 "src/parser.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2020 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_SPI; }
#line 5535 "src/parser.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2021 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_SEQUENCE; }
#line 5541 "src/parser.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2025 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_esp, (yyvsp[0].val));
			}
#line 5549 "src/parser.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2029 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_ESP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5560 "src/parser.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2037 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ESPHDR_SPI; }
#line 5566 "src/parser.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2038 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = ESPHDR_SEQUENCE; }
#line 5572 "src/parser.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2042 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_comp, (yyvsp[0].val));
			}
#line 5580 "src/parser.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2046 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_COMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5591 "src/parser.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2054 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = COMPHDR_NEXTHDR; }
#line 5597 "src/parser.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2055 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = COMPHDR_FLAGS; }
#line 5603 "src/parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2056 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = COMPHDR_CPI; }
#line 5609 "src/parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2060 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udp, (yyvsp[0].val));
			}
#line 5617 "src/parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2064 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_UDP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5628 "src/parser.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2072 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_SPORT; }
#line 5634 "src/parser.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2073 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_DPORT; }
#line 5640 "src/parser.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2074 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_LENGTH; }
#line 5646 "src/parser.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2075 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_CHECKSUM; }
#line 5652 "src/parser.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2079 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udplite, (yyvsp[0].val));
			}
#line 5660 "src/parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2083 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_UDPLITE;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5671 "src/parser.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2091 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_SPORT; }
#line 5677 "src/parser.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2092 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_DPORT; }
#line 5683 "src/parser.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2093 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_LENGTH; }
#line 5689 "src/parser.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2094 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_CHECKSUM; }
#line 5695 "src/parser.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2098 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_tcp, (yyvsp[0].val));
			}
#line 5703 "src/parser.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2102 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_TCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5714 "src/parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2110 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_SPORT; }
#line 5720 "src/parser.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2111 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_DPORT; }
#line 5726 "src/parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2112 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_SEQ; }
#line 5732 "src/parser.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2113 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_ACKSEQ; }
#line 5738 "src/parser.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2114 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_DOFF; }
#line 5744 "src/parser.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2115 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_RESERVED; }
#line 5750 "src/parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2116 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_FLAGS; }
#line 5756 "src/parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2117 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_WINDOW; }
#line 5762 "src/parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2118 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_CHECKSUM; }
#line 5768 "src/parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2119 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_URGPTR; }
#line 5774 "src/parser.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2123 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_dccp, (yyvsp[0].val));
			}
#line 5782 "src/parser.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2127 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_DCCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5793 "src/parser.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2135 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = DCCPHDR_SPORT; }
#line 5799 "src/parser.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2136 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = DCCPHDR_DPORT; }
#line 5805 "src/parser.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2137 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = DCCPHDR_TYPE; }
#line 5811 "src/parser.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2141 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_sctp, (yyvsp[0].val));
			}
#line 5819 "src/parser.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2145 "src/parser.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_SCTP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 5830 "src/parser.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2153 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_SPORT; }
#line 5836 "src/parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2154 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_DPORT; }
#line 5842 "src/parser.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2155 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_VTAG; }
#line 5848 "src/parser.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2156 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_CHECKSUM; }
#line 5854 "src/parser.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2169 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_hbh, (yyvsp[0].val));
			}
#line 5862 "src/parser.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2174 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = HBHHDR_NEXTHDR; }
#line 5868 "src/parser.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2175 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = HBHHDR_HDRLENGTH; }
#line 5874 "src/parser.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2179 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt, (yyvsp[0].val));
			}
#line 5882 "src/parser.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2184 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_NEXTHDR; }
#line 5888 "src/parser.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2185 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_HDRLENGTH; }
#line 5894 "src/parser.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2186 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_TYPE; }
#line 5900 "src/parser.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2187 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_SEG_LEFT; }
#line 5906 "src/parser.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2191 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt0, (yyvsp[0].val));
			}
#line 5914 "src/parser.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2197 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.val) = RT0HDR_ADDR_1 + (yyvsp[-1].val) - 1;
			}
#line 5922 "src/parser.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2203 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt2, (yyvsp[0].val));
			}
#line 5930 "src/parser.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2208 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = RT2HDR_ADDR; }
#line 5936 "src/parser.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2212 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_frag, (yyvsp[0].val));
			}
#line 5944 "src/parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2217 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_NEXTHDR; }
#line 5950 "src/parser.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2218 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_RESERVED; }
#line 5956 "src/parser.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2219 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_FRAG_OFF; }
#line 5962 "src/parser.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2220 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_RESERVED2; }
#line 5968 "src/parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2221 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_MFRAGS; }
#line 5974 "src/parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2222 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_ID; }
#line 5980 "src/parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2226 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_dst, (yyvsp[0].val));
			}
#line 5988 "src/parser.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2231 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = DSTHDR_NEXTHDR; }
#line 5994 "src/parser.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2232 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = DSTHDR_HDRLENGTH; }
#line 6000 "src/parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2236 "src/parser.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_mh, (yyvsp[0].val));
			}
#line 6008 "src/parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2241 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_NEXTHDR; }
#line 6014 "src/parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2242 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_HDRLENGTH; }
#line 6020 "src/parser.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2243 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_TYPE; }
#line 6026 "src/parser.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2244 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_RESERVED; }
#line 6032 "src/parser.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2245 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_CHECKSUM; }
#line 6038 "src/parser.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2248 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_OUTPUT_XML; }
#line 6044 "src/parser.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2249 "src/parser.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_OUTPUT_JSON; }
#line 6050 "src/parser.c" /* yacc.c:1646  */
    break;


#line 6054 "src/parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, scanner, state, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, scanner, state, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, scanner, state);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, scanner, state);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, scanner, state, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, scanner, state);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, scanner, state);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2251 "src/parser.y" /* yacc.c:1906  */

